#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Checkerboard.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Checkerboard.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 4 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Checkerboard.fx"
#line 10
uniform int _Help
<
ui_text =
"This effect generates a checkerboard pattern on the screen, which can "
"help testing overlay effects.\n"
"\n"
"To use it effectively, place it above the effect you wish to test, "
"like a vignette effect.\n"
"\n"
"You can change the color opacity for either of the two tile colors "
"separately.\n"
"\n"
"Note that some tile sizes may not align properly to the bottom "
"right.\n"
;
ui_category = "Help";
ui_category_closed = true;
ui_label = " ";
ui_type = "radio";
>;
#line 31
uniform float TileSize
<
     ui_type = "drag"; 
#line 35
ui_label = "Size";
ui_tooltip =
"The size of the checkerboard tiles.\n"
"\nDefault: 20";
ui_category = "Tiles";
ui_min = 1.0;
ui_max = 100.0;
ui_step = 1.0;
> = 20.0;
#line 45
uniform float4 TileColorA
<
     ui_type = "color"; 
#line 49
ui_label = "Color A";
ui_tooltip =
"The odd color of the pattern.\n"
"\nDefault: 89 89 89 255";
ui_category = "Tiles";
> = float4(0.35, 0.35, 0.35, 1.0);
#line 56
uniform float4 TileColorB
<
     ui_type = "color"; 
#line 60
ui_label = "Color B";
ui_tooltip =
"The even color of the pattern.\n"
"\nDefault: 166 166 166 255";
ui_category = "Tiles";
> = float4(0.65, 0.65, 0.65, 1.0);
#line 71
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(ReShade::BackBuffer, uv);
float2 coord = uv * ReShade::ScreenSize;
#line 76
float size = TileSize * 2.0;
float inv_size = rcp(size);
#line 79
float2 tiles = coord % size * inv_size;
tiles = step(0.5, tiles);
#line 82
float4 checkerboard = (tiles.x != tiles.y) ? TileColorA : TileColorB;
color.rgb = lerp(color.rgb, checkerboard.rgb, checkerboard.a);
#line 85
return color;
}
#line 92
technique Checkerboard
<
ui_tooltip =
"Display a simple checkerboard pattern to test overlay effects.\n"
"Place it above the effect you wish to test.\n"
;
>
{
pass
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
}
}

