#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Image.fx"
#line 29
uniform bool AspectCorrect <
ui_label = "Preserve aspect ratio";
ui_tooltip =
"To change image source add following to preprocessor definitions:\n"
"TEST_IMAGE_FILE 'filename.jpg'\n"
"TEST_IMAGE_X [horizontal resolution]\n"
"TEST_IMAGE_Y [vertical resolution]";
> = true;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 42 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Image.fx"
#line 45
texture ImageTex < source =  "image.png"; > {Width =  1440; Height =  1080;};
sampler ImageSampler { Texture = ImageTex; };
#line 49
float Border(float2 Coordinates)
{
Coordinates = abs(Coordinates*2-1); 
float2 Pixel = fwidth(Coordinates);
Coordinates = smoothstep(1.0+Pixel, 1.0-Pixel, Coordinates);
return min(Coordinates.x, Coordinates.y);
}
#line 58
float3 ImagePS(float4 vois : SV_Position, float2 texcoord : TexCoord) : SV_Target
{
float3 Display = tex2D(ReShade::BackBuffer, texcoord).rgb;
float4 ImageTex;
#line 63
if(!AspectCorrect)
{
ImageTex = tex2D(ImageSampler, texcoord);
return lerp(Display, ImageTex.rgb, ImageTex.a);
}
#line 69
float DisplayAspect = ReShade::AspectRatio;
float ImageAspect = float( 1440)/float( 1080);
float AspectDifference = DisplayAspect / ImageAspect;
#line 73
if(AspectDifference > 1.0)
{
texcoord.x -= 0.5;
texcoord.x *= AspectDifference;
texcoord.x += 0.5;
}
else if(AspectDifference < 1.0)
{
texcoord.y -= 0.5;
texcoord.y /= AspectDifference;
texcoord.y += 0.5;
}
else
{
ImageTex = tex2D(ImageSampler, texcoord);
return lerp(Display, ImageTex.rgb, ImageTex.a);
}
#line 91
ImageTex = tex2D(ImageSampler, texcoord);
#line 94
return lerp(
0.0,
lerp(Display, ImageTex.rgb, ImageTex.a),
Border(texcoord)
);
}
#line 105
technique ImageTest <
ui_label = "TEST image";
ui_tooltip =
"To change image file,\n"
"define global preprocessor definition:\n"
"  TEST_IMAGE 'image.png'\n"
"  TEST_IMAGE_X 1440\n"
"  TEST_IMAGE_Y 1080";
>
{
pass
{
VertexShader = PostProcessVS;
PixelShader = ImagePS;
}
}

