#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/API.fxh"
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Canvas.fxh"
#line 9
namespace FXShaders
{
#line 20
void FillRect(inout float4 color, float2 coord, float4 rect, float4 fillColor)
{
if (
coord.x >= rect.x && coord.x <= rect.z &&
coord.y >= rect.y && coord.y <= rect.w)
{
color = fillColor;
}
}
#line 36
float4 ConvertToRect(float2 pos, float2 size)
{
return mad(float2(-0.5, 0.5).xxyy, size.xyxy, pos.xyxy);
}
#line 54
bool AABBCollision(float4 a, float4 b)
{
return
a.x < b.z && b.x < a.z &&
a.y < b.w && b.y < a.w;
}
#line 61
}
#line 4 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3
namespace FXShaders
{
#line 68
static const float Pi = 3.14159;
#line 73
static const float DegreesToRadians = Pi / 180.0;
#line 78
static const float RadiansToDegrees = 180.0 / Pi;
#line 87
float2 GetOffsetByAngleDistance(float2 pos, float angle, float distance)
{
float2 cosSin;
sincos(angle, cosSin.y, cosSin.x);
#line 92
return mad(distance, cosSin, pos);
}
#line 102
float2 GetDirectionFromAngleMagnitude(float angle, float magnitude)
{
return GetOffsetByAngleDistance(0.0, angle, magnitude);
}
#line 114
float2 ClampMagnitude(float2 v, float2 minMax) {
if (v.x == 0.0 && v.y == 0.0)
{
return 0.0;
}
else
{
float mag = length(v);
return (mag < minMax.x) ? 0.0 : (v / mag) * min(mag, minMax.y);
}
}
#line 133
float2 RotatePoint(float2 uv, float angle, float2 pivot)
{
float2 sc;
sincos(DegreesToRadians * angle, sc.x, sc.y);
#line 138
uv -= pivot;
uv = uv.x * sc.yx + float2(-uv.y, uv.y) * sc;
uv += pivot;
#line 142
return uv;
}
#line 145
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 11
namespace FXShaders
{
#line 18
static const float FloatEpsilon = 0.001;
#line 125
float2 GetResolution()
{
return float2(3840, 2160);
}
#line 133
float2 GetPixelSize()
{
return float2((1.0 / 3840), (1.0 / 2160));
}
#line 141
float GetAspectRatio()
{
return 3840 * (1.0 / 2160);
}
#line 149
float4 GetScreenParams()
{
return float4(GetResolution(), GetPixelSize());
}
#line 165
float2 ScaleCoord(float2 uv, float2 scale, float2 pivot)
{
return (uv - pivot) * scale + pivot;
}
#line 178
float2 ScaleCoord(float2 uv, float2 scale)
{
return ScaleCoord(uv, scale, 0.5);
}
#line 188
float GetLumaGamma(float3 color)
{
return dot(color, float3(0.299, 0.587, 0.114));
}
#line 199
float GetLumaLinear(float3 color)
{
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 212
float3 checkered_pattern(float2 uv, float size, float color_a, float color_b)
{
static const float cSize = 32.0;
static const float3 cColorA = pow(0.15, 2.2);
static const float3 cColorB = pow(0.5, 2.2);
#line 218
uv *= GetResolution();
uv %= cSize;
#line 221
float half_size = cSize * 0.5;
float checkered = step(uv.x, half_size) == step(uv.y, half_size);
return (cColorA * checkered) + (cColorB * (1.0 - checkered));
}
#line 232
float3 checkered_pattern(float2 uv)
{
static const float Size = 32.0;
static const float ColorA = pow(0.15, 2.2);
static const float ColorB = pow(0.5, 2.2);
#line 238
return checkered_pattern(uv, Size, ColorA, ColorB);
}
#line 251
float3 ApplySaturation(float3 color, float amount)
{
float gray = GetLumaLinear(color);
return gray + (color - gray) * amount;
}
#line 262
float GetRandom(float2 uv)
{
#line 267
static const float A = 23.2345;
static const float B = 84.1234;
static const float C = 56758.9482;
#line 271
return frac(sin(dot(uv, float2(A, B))) * C);
}
#line 281
void ScreenVS(
uint id : SV_VERTEXID,
out float4 pos : SV_POSITION,
out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
#line 289
pos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 300
float2 CorrectAspectRatio(float2 uv, float a, float b)
{
if (a > b)
{
#line 306
uv = ScaleCoord(uv, float2(1.0 / a, 1.0));
}
else
{
#line 312
uv = ScaleCoord(uv, float2(1.0, 1.0 / b));
}
#line 315
return uv;
}
#line 318
} 
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Convolution.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Convolution.fxh"
#line 5
namespace FXShaders
{
#line 18
float NormalDistribution(float x, float u, float o)
{
o *= o;
#line 22
float a = 1.0 / sqrt(2.0 * Pi * o);
float b = x - u;
b *= b;
b /= 2.0 * o;
#line 27
return a * exp(-(b));
}
#line 38
float Gaussian1D(float x, float o)
{
o *= o;
float a = 1.0 / sqrt(2.0 * Pi * o);
float b = (x * x) / (2.0 * o);
return a * exp(-b);
}
#line 55
float Gaussian1DFast(float x, float o)
{
#line 59
return exp(-(x * x) / (2.0 * o * o));
}
#line 70
float Gaussian2D(float2 i, float o)
{
o *= o;
float a = 1.0 / (2.0 * Pi * o);
float b = (i.x * i.x + i.y * i.y) / (2.0 * o);
return a * exp(-b);
}
#line 91
float4 GaussianBlur1D(
sampler sp,
float2 uv,
float2 dir,
float sigma,
int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
#line 100
float4 color = 0.0;
float accum = 0.0;
#line 103
uv -= halfSamples * dir;
#line 105
[unroll]
for (int i = 0; i < samples; ++i)
{
float weight = Gaussian1DFast(i - halfSamples, sigma);
#line 110
color += tex2D(sp, uv) * weight;
accum += weight;
#line 113
uv += dir;
}
#line 116
return color / accum;
}
#line 132
float4 GaussianBlur2D(
sampler sp,
float2 uv,
float2 scale,
float sigma,
int2 samples)
{
static const float2 halfSamples = samples * 0.5;
#line 141
float4 color = 0.0;
float accum = 0.0;
#line 144
uv -= halfSamples * scale;
#line 146
[unroll]
for (int x = 0; x < samples.x; ++x)
{
float initX = uv.x;
#line 151
[unroll]
for (int y = 0; y < samples.y; ++y)
{
float2 pos = float2(x, y);
float weight = Gaussian2D(abs(pos - halfSamples), sigma);
#line 157
color += tex2D(sp, uv) * weight;
accum += weight;
#line 160
uv.x += scale.x;
}
#line 163
uv.x = initX;
uv.y += scale.y;
}
#line 167
return color / accum;
}
#line 170
float4 LinearBlur1D(sampler sp, float2 uv, float2 dir, int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
uv -= halfSamples * dir;
#line 175
float4 color = 0.0;
#line 177
[unroll]
for (int i = 0; i < samples; ++i)
{
color += tex2D(sp, uv);
uv += dir;
}
#line 184
return color / samples;
}
#line 187
float4 MaxBlur1D(sampler sp, float2 uv, float2 dir, int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
uv -= halfSamples * dir;
#line 192
float4 color = 0.0;
#line 194
[unroll]
for (int i = 0; i < samples; ++i)
{
color = max(color, tex2D(sp, uv));
uv += dir;
}
#line 201
return color;
}
#line 204
float4 SharpBlur1D(sampler sp, float2 uv, float2 dir, int samples, float sharpness)
{
static const float halfSamples = (samples - 1) * 0.5;
static const float weight = 1.0 / samples;
#line 209
uv -= halfSamples * dir;
#line 211
float4 color = 0.0;
#line 213
[unroll]
for (int i = 0; i < samples; ++i)
{
float4 pixel = tex2D(sp, uv);
color = lerp(color + pixel * weight, max(color, pixel), sharpness);
uv += dir;
}
#line 221
return color;
}
#line 224
} 
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Tonemap.fxh"
#line 11
namespace FXShaders { namespace Tonemap
{
#line 14
namespace Type
{
static const int Reinhard = 0;
static const int Uncharted2Filmic = 1;
static const int BakingLabACES = 2;
static const int NarkowiczACES = 3;
static const int Unreal3 = 4;
static const int Lottes = 5;
}
#line 24
namespace Reinhard
{
#line 31
float3 Apply(float3 color)
{
return color / (1.0 + color);
}
#line 41
float3 Inverse(float3 color)
{
return -(color / min(color - 1.0, -0.1));
}
#line 55
float3 InverseOld(float3 color, float w)
{
return color / max(1.0 - color, w);
}
#line 69
float3 InverseOldLum(float3 color, float w)
{
float lum = max(color.r, max(color.g, color.b));
return color * (lum / max(1.0 - lum, w));
}
}
#line 76
namespace Uncharted2Filmic
{
#line 79
static const float A = 0.15;
#line 82
static const float B = 0.50;
#line 85
static const float C = 0.10;
#line 88
static const float D = 0.20;
#line 91
static const float E = 0.02;
#line 94
static const float F = 0.30;
#line 96
float3 Apply(float3 color)
{
color =
(
(color * (A * color + C * B) + D * E) /
(color * (A * color + B) + D * F)
) - E / F;
#line 104
return color;
}
#line 107
float3 Inverse(float3 color)
{
return abs(
((B * C * F - B * E - B * F * color) -
sqrt(
pow(abs(-B * C * F + B * E + B * F * color), 2.0) -
4.0 * D * (F * F) * color * (A * E + A * F * color - A * F))) /
(2.0 * A * (E + F * color - F)));
}
}
#line 118
namespace BakingLabACES
{
#line 121
static const float3x3 ACESInputMat = float3x3
(
0.59719, 0.35458, 0.04823,
0.07600, 0.90834, 0.01566,
0.02840, 0.13383, 0.83777
);
#line 129
static const float3x3 ACESOutputMat = float3x3
(
1.60475, -0.53108, -0.07367,
-0.10208,  1.10813, -0.00605,
-0.00327, -0.07276,  1.07602
);
#line 136
float3 RRTAndODTFit(float3 v)
{
float3 a = v * (v + 0.0245786f) - 0.000090537f;
float3 b = v * (0.983729f * v + 0.4329510f) + 0.238081f;
return a / b;
}
#line 143
float3 ACESFitted(float3 color)
{
color = mul(ACESInputMat, color);
#line 148
color = RRTAndODTFit(color);
#line 150
color = mul(ACESOutputMat, color);
#line 153
color = saturate(color);
#line 155
return color;
}
#line 158
static const float A = 0.0245786;
static const float B = 0.000090537;
static const float C = 0.983729;
static const float D = 0.4329510;
static const float E = 0.238081;
#line 164
float3 Apply(float3 color)
{
return saturate(
(color * (color + A) - B) /
(color * (C * color + D) + E));
}
#line 171
float3 Inverse(float3 color)
{
return abs(
((A - D * color) -
sqrt(
pow(abs(D * color - A), 2.0) -
4.0 * (C * color - 1.0) * (B + E * color))) /
(2.0 * (C * color - 1.0)));
}
}
#line 182
namespace Lottes
{
float3 Apply(float3 color)
{
return color * rcp(max(color.r, max(color.g, color.b)) + 1.0);
}
#line 189
float3 Inverse(float3 color)
{
return color * rcp(max(1.0 - max(color.r, max(color.g, color.b)), 0.1));
}
}
#line 195
namespace NarkowiczACES
{
static const float A = 2.51;
static const float B = 0.03;
static const float C = 2.43;
static const float D = 0.59;
static const float E = 0.14;
#line 203
float3 Apply(float3 color)
{
return saturate(
(color * (A * color + B)) / (color * (C * color + D) + E));
}
#line 209
float3 Inverse(float3 color)
{
return
((D * color - B) +
sqrt(
4.0 * A * E * color + B * B -
2.0 * B * D * color -
4.0 * C * E * color * color +
D * D * color * color)) /
(2.0 * (A - C * color));
}
}
#line 222
namespace Unreal3
{
float3 Apply(float3 color)
{
return color / (color + 0.155) * 1.019;
}
#line 229
float3 Inverse(float3 color)
{
return (color * -0.155) / (max(color, 0.01) - 1.019);
}
}
#line 235
float3 Apply(int type, float3 color)
{
switch (type)
{
case Type::Reinhard:
return Reinhard::Apply(color);
case Type::Uncharted2Filmic:
return Uncharted2Filmic::Apply(color);
case Type::BakingLabACES:
return BakingLabACES::Apply(color);
case Type::NarkowiczACES:
return NarkowiczACES::Apply(color);
case Type::Unreal3:
return Unreal3::Apply(color);
case Type::Lottes:
return Lottes::Apply(color);
}
#line 253
return color;
}
#line 256
float3 Inverse(int type, float3 color)
{
switch (type)
{
case Type::Reinhard:
return Reinhard::Inverse(color);
case Type::Uncharted2Filmic:
return Uncharted2Filmic::Inverse(color);
case Type::BakingLabACES:
return BakingLabACES::Inverse(color);
case Type::NarkowiczACES:
return NarkowiczACES::Inverse(color);
case Type::Unreal3:
return Unreal3::Inverse(color);
case Type::Lottes:
return Lottes::Inverse(color);
}
#line 274
return color;
}
#line 277
}} 
#line 8 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\MagicHDR.fx"
#line 44
namespace FXShaders
{
#line 49
static const int2 DownsampleAmount =  4;
#line 51
static const int BlurSamples =  13;
#line 53
static const float2 AdaptFocusPointDebugSize = 10.0;
#line 55
static const int
InvTonemap_Reinhard = 0,
InvTonemap_Lottes = 1,
InvTonemap_Unreal3 = 2,
InvTonemap_NarkowiczACES = 3,
InvTonemap_Uncharted2Filmic = 4,
InvTonemap_BakingLabACES = 5;
#line 63
static const int
Tonemap_Reinhard = 0,
Tonemap_Lottes = 1,
Tonemap_Unreal3 = 2,
Tonemap_NarkowiczACES = 3,
Tonemap_Uncharted2Filmic = 4,
Tonemap_BakingLabACES = 5;
#line 75
  uniform int _WipWarn < ui_text = "This effect is currently a work in progress and as such some " "aspects may change in the future and some features may still be " "missing or incomplete.\n"; ui_label = " "; ui_type = "radio"; >;
#line 77
  uniform int _Credits < ui_text = "This effect was made by Lucas Melo (luluco250).\n" "Updates may be available at https://github.com/luluco250/FXShaders\n" "Any issues, suggestions or requests can also be filed there."; ui_category = "Credits"; ui_category_closed = true; ui_label = " "; ui_type = "radio"; >;
#line 183
uniform int _Help < ui_text =
"This effect allows you to add both bloom and tonemapping, drastically "
"changing the mood of the image.\n"
"\n"
"Care should be taken to select an appropriate inverse tonemapper that can "
"accurately extract HDR information from the original image.\n"
"HDR10 users should also take care to select a tonemapper that's "
"compatible with what the HDR monitor is expecting from the LDR output of "
"the game, which *is* tonemapped too.\n"
"\n"
"Available preprocessor directives:\n"
"\n"
"MAGIC_HDR_BLUR_SAMPLES:\n"
"  Determines how many pixels are sampled during each blur pass for the "
"bloom effect.\n"
"  This value directly influences the Blur Size, so the more samples the "
"bigger the blur size can be.\n"
"  Setting MAGIC_HDR_DOWNSAMPLE above 1x will also increase the blur size "
"to compensate for the lower resolution. This effect may be desirable, "
"however.\n"
"\n"
"MAGIC_HDR_DOWNSAMPLE:\n"
"  Serves to divide the resolution of the textures used for processing the "
"bloom effect.\n"
"  Leave at 1x for maximum detail, 2x or 4x should still be fine.\n"
"  Values too high may introduce flickering.\n"
#line 105
; ui_category = "Help"; ui_category_closed = true; ui_label = " "; ui_type = "radio"; >;
#line 107
uniform float InputExposure
<
ui_category = "Tonemapping";
ui_label = "Input Exposure";
ui_tooltip =
"Approximate exposure of the original image.\n"
"This value is measured in f-stops.\n"
"\nDefault: 1.0";
ui_type = "slider";
ui_min = -3.0;
ui_max = 3.0;
> = 0.0;
#line 120
uniform float Exposure
<
ui_category = "Tonemapping";
ui_label = "Output Exposure";
ui_tooltip =
"Exposure applied at the end of the effect.\n"
"This value is measured in f-stops.\n"
"\nDefault: 1.0";
ui_type = "slider";
ui_min = -3.0;
ui_max = 3.0;
> = 0.0;
#line 133
uniform int InvTonemap
<
ui_category = "Tonemapping";
ui_label = "Inverse Tonemapper";
ui_tooltip =
"The inverse tonemapping operator used to obtain HDR information.\n"
"\nDefault: Reinhard";
ui_type = "combo";
ui_items =
"Reinhard\0Lottes\0Unreal 3\0Narkowicz ACES\0Uncharted 2 Filmic\0Baking Lab ACES\0";
> = InvTonemap_Reinhard;
#line 145
uniform int Tonemap
<
ui_category = "Tonemapping";
ui_label = "Output Tonemapper";
ui_tooltip =
"The tonemapping operator applied at the end of the effect.\n"
"\nDefault: Baking Lab ACES";
ui_type = "combo";
ui_items =
"Reinhard\0Lottes\0Unreal 3\0Narkowicz ACES\0Uncharted 2 Filmic\0Baking Lab ACES\0";
> = Tonemap_BakingLabACES;
#line 157
uniform float BloomAmount
<
ui_category = "Bloom";
ui_category_closed = true;
ui_label = "Amount";
ui_tooltip =
"The amount of bloom to apply to the image.\n"
"\nDefault: 0.3";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
> = 0.3;
#line 170
uniform float BloomBrightness
<
ui_category = "Bloom";
ui_label = "Brightness";
ui_tooltip =
"This value is used to multiply the bloom texture brightness.\n"
"This is different from the amount in it directly affects the "
"brightness, rather than acting as a percentage of blending between "
"the HDR color and the bloom color.\n"
"\nDefault: 3.0";
ui_type = "slider";
ui_min = 1.0;
ui_max = 5.0;
> = 3.0;
#line 185
uniform float BloomSaturation
<
ui_category = "Bloom";
ui_label = "Saturation";
ui_tooltip =
"Determines the saturation of bloom.\n"
"\nDefault: 1.0";
ui_type = "slider";
ui_min = 0.0;
ui_max = 2.0;
> = 1.0;
#line 197
uniform float BlurSize
<
ui_category = "Bloom - Advanced";
ui_category_closed = true;
ui_label = "Blur Size";
ui_tooltip =
"The size of the gaussian blur applied to create the bloom effect.\n"
"This value is directly influenced by the values of "
"MAGIC_HDR_BLUR_SAMPLES and MAGIC_HDR_DOWNSAMPLE.\n"
"\nDefault: 0.5";
ui_type = "slider";
ui_min = 0.01;
ui_max = 1.0;
> = 0.5;
#line 212
uniform float BlendingAmount
<
ui_category = "Bloom - Advanced";
ui_label = "Blending Amount";
ui_tooltip =
"How much to blend the various bloom textures used internally.\n"
"Reducing this value will make the bloom more uniform, with less "
"variation.\n"
"\nDefault: 0.5";
ui_type = "slider";
ui_min = 0.1;
ui_max = 1.0;
> = 0.5;
#line 226
uniform float BlendingBase
<
ui_category = "Bloom - Advanced";
ui_label = "Blending Base";
ui_tooltip =
"Determines the base bloom size when blending.\n"
"It's more effective with a lower Blending Amount.\n"
"\nDefault: 0.8";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
> = 0.8;
#line 323
uniform bool ShowBloom
<
ui_category = "Debug";
ui_category_closed = true;
ui_label = "Show Bloom";
ui_tooltip =
"Displays the bloom texture.\n"
"\nDefault: Off";
> = false;
#line 350
texture ColorTex : COLOR;
#line 352
sampler Color
{
Texture = ColorTex;
#line 357
SRGBTexture = true;
#line 359
};
#line 376
 texture TempTex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 1; Height = 2160 / DownsampleAmount.y / 1; Format = RGBA16F; MipLevels = 1; }; sampler Temp { Texture = TempTex; };
#line 379
 texture Bloom0Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 1; Height = 2160 / DownsampleAmount.y / 1; Format = RGBA16F; MipLevels = 1; }; sampler Bloom0 { Texture = Bloom0Tex; };
 texture Bloom1Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 2; Height = 2160 / DownsampleAmount.y / 2; Format = RGBA16F; MipLevels = 1; }; sampler Bloom1 { Texture = Bloom1Tex; };
 texture Bloom2Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 4; Height = 2160 / DownsampleAmount.y / 4; Format = RGBA16F; MipLevels = 1; }; sampler Bloom2 { Texture = Bloom2Tex; };
 texture Bloom3Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 8; Height = 2160 / DownsampleAmount.y / 8; Format = RGBA16F; MipLevels = 1; }; sampler Bloom3 { Texture = Bloom3Tex; };
 texture Bloom4Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 16; Height = 2160 / DownsampleAmount.y / 16; Format = RGBA16F; MipLevels = 1; }; sampler Bloom4 { Texture = Bloom4Tex; };
 texture Bloom5Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 32; Height = 2160 / DownsampleAmount.y / 32; Format = RGBA16F; MipLevels = 1; }; sampler Bloom5 { Texture = Bloom5Tex; };
#line 412
 texture Bloom6Tex <pooled = true;> { Width = 3840 / DownsampleAmount.x / 64; Height = 2160 / DownsampleAmount.y / 64; Format = RGBA16F; MipLevels = 1; }; sampler Bloom6 { Texture = Bloom6Tex; };
#line 444
float3 ApplyInverseTonemap(float3 color, float2 uv)
{
switch (InvTonemap)
{
case InvTonemap_Reinhard:
color = Tonemap::Reinhard::Inverse(color);
break;
case InvTonemap_Lottes:
color = Tonemap::Lottes::Inverse(color);
break;
case InvTonemap_Unreal3:
color = Tonemap::Unreal3::Inverse(color);
break;
case InvTonemap_NarkowiczACES:
color = Tonemap::NarkowiczACES::Inverse(color);
break;
case InvTonemap_Uncharted2Filmic:
color = Tonemap::Uncharted2Filmic::Inverse(color);
break;
case InvTonemap_BakingLabACES:
color = Tonemap::BakingLabACES::Inverse(color);
break;
}
#line 468
color /= exp(InputExposure);
#line 470
return color;
}
#line 473
float3 ApplyTonemap(float3 color, float2 uv)
{
float exposure = exp(Exposure);
#line 481
switch (Tonemap)
{
case Tonemap_Reinhard:
color = Tonemap::Reinhard::Apply(color * exposure);
break;
case Tonemap_Lottes:
color = Tonemap::Lottes::Apply(color * exposure);
break;
case Tonemap_Unreal3:
color = Tonemap::Unreal3::Apply(color * exposure);
break;
case Tonemap_NarkowiczACES:
color = Tonemap::NarkowiczACES::Apply(color * exposure);
break;
case Tonemap_Uncharted2Filmic:
color = Tonemap::Uncharted2Filmic::Apply(color * exposure);
break;
case Tonemap_BakingLabACES:
color = Tonemap::BakingLabACES::Apply(color * exposure);
break;
}
#line 503
return color;
}
#line 506
float4 Blur(sampler sp, float2 uv, float2 dir)
{
float4 color = GaussianBlur1D(
sp,
uv,
dir * GetPixelSize() * DownsampleAmount,
sqrt(BlurSamples) * BlurSize,
BlurSamples);
#line 515
return color;
}
#line 531
float4 InverseTonemapPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(Color, uv);
#line 537
float saturation = (BloomSaturation > 1.0)
? pow(abs(BloomSaturation), 2.0)
: BloomSaturation;
#line 541
color.rgb = saturate(ApplySaturation(color.rgb, saturation));
#line 543
color.rgb = ApplyInverseTonemap(color.rgb, uv);
#line 546
color.rgb *= exp(BloomBrightness);
#line 548
return color;
}
#line 566
 float4 Blur0PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom0, uv, float2(1, 0.0)); } float4 Blur1PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 1)); }
 float4 Blur2PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom0, uv, float2(2, 0.0)); } float4 Blur3PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 2)); }
 float4 Blur4PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom1, uv, float2(4, 0.0)); } float4 Blur5PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 4)); }
 float4 Blur6PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom2, uv, float2(8, 0.0)); } float4 Blur7PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 8)); }
 float4 Blur8PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom3, uv, float2(16, 0.0)); } float4 Blur9PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 16)); }
 float4 Blur10PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom4, uv, float2(32, 0.0)); } float4 Blur11PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 32)); }
 float4 Blur12PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Bloom5, uv, float2(64, 0.0)); } float4 Blur13PS( float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET { return Blur(Temp, uv, float2(0.0, 64)); }
#line 623
float4 TonemapPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD) : SV_TARGET
{
#line 655
float4 color = tex2D(Color, uv);
color.rgb = ApplyInverseTonemap(color.rgb, uv);
#line 658
float mean = BlendingBase * 7;
float variance = BlendingAmount * 7;
#line 661
float4 bloom =
tex2D(Bloom0, uv) * NormalDistribution(1, mean, variance) +
tex2D(Bloom1, uv) * NormalDistribution(2, mean, variance) +
tex2D(Bloom2, uv) * NormalDistribution(3, mean, variance) +
tex2D(Bloom3, uv) * NormalDistribution(4, mean, variance) +
tex2D(Bloom4, uv) * NormalDistribution(5, mean, variance) +
tex2D(Bloom5, uv) * NormalDistribution(6, mean, variance) +
tex2D(Bloom6, uv) * NormalDistribution(7, mean, variance);
#line 670
bloom /= 7;
#line 672
color.rgb = ShowBloom
? bloom.rgb
: lerp(color.rgb, bloom.rgb, log10(BloomAmount + 1.0));
#line 676
color.rgb = ApplyTonemap(color.rgb, uv);
#line 678
return color;
}
#line 685
technique MagicHDR <ui_tooltip = "FXShaders - Bloom and tonemapping effect.";>
{
pass InverseTonemap
{
VertexShader = ScreenVS;
PixelShader = InverseTonemapPS;
RenderTarget = Bloom0Tex;
}
#line 708
 pass Blur0 { VertexShader = ScreenVS; PixelShader = Blur0PS; RenderTarget = TempTex; } pass Blur1 { VertexShader = ScreenVS; PixelShader = Blur1PS; RenderTarget = Bloom0Tex; }
 pass Blur2 { VertexShader = ScreenVS; PixelShader = Blur2PS; RenderTarget = TempTex; } pass Blur3 { VertexShader = ScreenVS; PixelShader = Blur3PS; RenderTarget = Bloom1Tex; }
 pass Blur4 { VertexShader = ScreenVS; PixelShader = Blur4PS; RenderTarget = TempTex; } pass Blur5 { VertexShader = ScreenVS; PixelShader = Blur5PS; RenderTarget = Bloom2Tex; }
 pass Blur6 { VertexShader = ScreenVS; PixelShader = Blur6PS; RenderTarget = TempTex; } pass Blur7 { VertexShader = ScreenVS; PixelShader = Blur7PS; RenderTarget = Bloom3Tex; }
 pass Blur8 { VertexShader = ScreenVS; PixelShader = Blur8PS; RenderTarget = TempTex; } pass Blur9 { VertexShader = ScreenVS; PixelShader = Blur9PS; RenderTarget = Bloom4Tex; }
 pass Blur10 { VertexShader = ScreenVS; PixelShader = Blur10PS; RenderTarget = TempTex; } pass Blur11 { VertexShader = ScreenVS; PixelShader = Blur11PS; RenderTarget = Bloom5Tex; }
 pass Blur12 { VertexShader = ScreenVS; PixelShader = Blur12PS; RenderTarget = TempTex; } pass Blur13 { VertexShader = ScreenVS; PixelShader = Blur13PS; RenderTarget = Bloom6Tex; }
#line 731
pass Tonemap
{
VertexShader = ScreenVS;
PixelShader = TonemapPS;
#line 737
SRGBWriteEnable = true;
#line 739
}
}
#line 744
} 

