#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\PerfectPerspective2.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 25 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\PerfectPerspective2.fx"
#line 29
uniform int FovAngle <        ui_type = "slider"; 
ui_category = "Game field-of-view"; ui_category_closed = false;
ui_label = "FOV angle";
ui_tooltip = "This setting should match your in-game FOV (in degrees).";
#line 36
ui_min = 0; ui_max = 170;
> = 90;
#line 39
uniform int FovType <        ui_type = "combo"; 
ui_category = "Game field-of-view";
ui_label = "FOV type";
ui_tooltip = "This setting should match your in-game FOV type.\n"
"\nIn stereographic mode (ref. option), adjust\n"
"such that round objects are still round, not oblong,\n"
"when at corners.\n"
"\nIf image bulges in movement (too high FOV),\n"
"change it to 'Diagonal'.\n"
"When proportions are distorted at the periphery\n"
"(too low FOV), choose 'Vertical' or '4:3'.\n"
"For ultra-wide display you may want '16:9' instead.";
ui_items =
"horizontal\0"
"diagonal\0"
"vertical\0"
"4:3\0"
"16:9\0";
> = 0;
#line 61
uniform int SimplePresets <        ui_type = "radio"; 
ui_category = "Presets"; ui_category_closed = false;
ui_label = "Gaming style";
ui_tooltip = "Choose preferable gaming style.\n\n"
"Shooting    [0.0 0.75 -0.5]  (aiming, panini, distance)\n"
"Racing      [0.5 -0.5 0.0]   (cornering, distance, speed)\n"
"Skating     [0.5 0.5]        (stereographic lens)\n"
"Flying      [-0.5 0.0]       (distance, pitch)\n"
"Stereopsis  [0.0 -0.5]       (aiming, distance)\n"
"Cinematic   [0.618 0.862]    (panini-anamorphic)\n";
ui_items =
"shooting (as.)\0"
"racing (as.)\0"
"skating (ref.)\0"
"flying\0"
"stereopsis\0"
"cinematic\0";
> = 2;
#line 81
uniform bool Manual <       ui_type = "input"; 
ui_category = "Manual"; ui_category_closed = true;
ui_label = "enable Manual";
ui_tooltip = "Change horizontal and vertical perspective manually.";
> = false;
#line 87
uniform bool AsymmetricalManual <       ui_type = "input"; 
ui_category = "Manual";
ui_label = "enable Asymmetrical";
ui_spacing = 1;
ui_tooltip = "Third option drives the bottom half of the screen.";
> = false;
#line 94
uniform int PresetKx <        ui_type = "list"; 
ui_category = "Manual";
ui_label = "Horizontal persp.";
ui_tooltip = "Kx\n"
"\nProjection type for horizontal axis.";
ui_items =
"shape,angles\0"
"speed,aim\0"
"distance,size\0";
> = 0;
#line 105
uniform int PresetKy <        ui_type = "list"; 
ui_category = "Manual";
ui_label = "Vertical persp.";
ui_tooltip = "Ky\n"
"\nProjection type for vertical axis.";
ui_items =
"shape,angles\0"
"speed,aim\0"
"distance,size\0";
> = 0;
#line 116
uniform int PresetKz <        ui_type = "list"; 
ui_category = "Manual";
ui_label = "Vertical bottom (as.)";
ui_tooltip = "Kz\n"
"\nProjection type for bottom-vertical axis,\n"
"an asymmetrical perspective.";
ui_items =
"shape,angles\0"
"speed,aim\0"
"distance,size\0";
> = 0;
#line 129
uniform bool Expert <       ui_type = "input"; 
ui_category = "Expert"; ui_category_closed = true;
ui_label = "enable Expert";
ui_tooltip = "Change pantomorphic K values manually.";
> = false;
#line 135
uniform bool AsymmetricalExpert <       ui_type = "input"; 
ui_category = "Expert";
ui_label = "enable Asymmetrical";
ui_spacing = 1;
ui_tooltip = "Third value of K, drives the bottom-half of the screen.";
> = false;
#line 142
uniform float3 K <      ui_type = "slider"; 
ui_category = "Expert";
ui_label = "K pantomorphic";
ui_tooltip =
"K   1   Rectilinear projection (standard), preserves straight lines,"
" but doesn't preserve proportions, angles or scale.\n"
"K  0.5  Stereographic projection (navigation, shapes) preserves angles and proportions,"
" best for navigation through tight spaces.\n"
"K   0   Equidistant (aiming) maintains angular speed of motion,"
" best for aiming at fast targets.\n"
"K -0.5  Equisolid projection (distances) preserves area relation,"
" best for navigation in open spaces.\n"
"K  -1   Orthographic projection preserves planar luminance as cosine-law,"
" has extreme radial compression. Found in peephole viewer.";
ui_min = -1; ui_max = 1;
> = float3(1, 1, 1);
#line 161
uniform float Zoom <      ui_type = "drag"; 
ui_category = "Border settings"; ui_category_closed = true;
ui_label = "Scale image";
ui_tooltip = "Adjust image scale and cropped area size.";
ui_min = 0.8; ui_max = 1.5; ui_step = 0.001;
> = 1;
#line 168
uniform float4 BorderColor <      ui_type = "color"; 
ui_category = "Border settings";
ui_label = "Border color";
ui_tooltip = "Use Alpha to change transparency.";
> = float4(0.027, 0.027, 0.027, 0.5);
#line 174
uniform float BorderCorners <      ui_type = "slider"; 
ui_category = "Border settings";
ui_label = "Corner roundness";
ui_spacing = 2;
ui_tooltip = "Represents corners curvature.\n"
"Value of 0, gives sharp corners.";
ui_min = 0; ui_max = 1;
> = 0.0862;
#line 183
uniform bool MirrorBorder <       ui_type = "input"; 
ui_category = "Border settings";
ui_label = "Mirror background";
ui_tooltip = "Choose original or mirrored image at the border";
> = true;
#line 189
uniform int VignettingStyle <        ui_type = "radio"; 
ui_category = "Border settings";
ui_label = "Vignetting style";
ui_spacing = 1;
ui_tooltip = "Redering options for automatic vignette.";
ui_items =
"vignette turned off\0"
"vignette inside\0"
"vignette on borders\0";
> = 1;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 213 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\PerfectPerspective2.fx"
#line 216
sampler BackBuffer
{
Texture = ReShade::BackBufferTex;
AddressU = MIRROR;
AddressV = MIRROR;
#line 224
};
#line 240
float aastep(float grad)
{
float2 Del = float2(ddx(grad), ddy(grad));
return saturate(rsqrt(dot(Del, Del))*grad+0.5);
}
#line 254
float glength(int G, float2 pos)
{
if (G<=0) return max(abs(pos.x), abs(pos.y)); 
pos = pow(abs(pos), ++G); 
return pow(pos.x+pos.y, rcp(G)); 
}
#line 274
float pantomorphic(float halfOmega, float2 k, inout float2 viewcoord)
{
#line 277
if (halfOmega==0.0) return 1.0;
#line 280
float rcp_f;
{
#line 283
if      (k.x>0.0) rcp_f = tan(k.x*halfOmega)/k.x;
else if (k.x<0.0) rcp_f = sin(k.x*halfOmega)/k.x;
else              rcp_f = halfOmega;
}
#line 289
float r = length(viewcoord);
#line 292
float2 theta2;
{
#line 295
if      (k.x>0.0) theta2.x = atan(r*k.x*rcp_f)/k.x;
else if (k.x<0.0) theta2.x = asin(r*k.x*rcp_f)/k.x;
else              theta2.x = r*rcp_f;
#line 299
if      (k.y>0.0) theta2.y = atan(r*k.y*rcp_f)/k.y;
else if (k.y<0.0) theta2.y = asin(r*k.y*rcp_f)/k.y;
else              theta2.y = r*rcp_f;
}
#line 305
float2 philerp = viewcoord*viewcoord; philerp /= philerp.x+philerp.y; 
#line 308
float vignetteMask; if (VignettingStyle!=0)
{	
float2 vignetteMask2 = cos(max(abs(k), 0.5)*theta2);
#line 312
vignetteMask2 = pow(abs(vignetteMask2), k*0.5+1.5);
#line 314
vignetteMask = dot(vignetteMask2, philerp);
} else vignetteMask = 1.0; 
#line 318
float theta = dot(theta2, philerp);
#line 320
viewcoord *= tan(theta)/(tan(halfOmega)*r);
#line 322
return vignetteMask;
}
#line 331
float BorderMaskPS(float2 borderCoord)
{
#line 334
borderCoord = abs(borderCoord);
if (BorderCorners!=0.0) 
{
#line 338
if ( (3840 * (1.0 / 2160))>1.0) 
borderCoord.x = borderCoord.x* (3840 * (1.0 / 2160))+(1.0- (3840 * (1.0 / 2160)));
else if ( (3840 * (1.0 / 2160))<1.0) 
borderCoord.y = borderCoord.y* (2160*(1.0 / 3840))+(1.0- (2160*(1.0 / 3840)));
#line 343
borderCoord = max(borderCoord+(BorderCorners-1.0), 0.0)/BorderCorners;
#line 345
return aastep(glength( 2, borderCoord)-1.0); 
} 
else return aastep(glength(0, borderCoord)-1.0);
}
#line 351
float3 PantomorphicPS(float4 pos : SV_Position, float2 texCoord : TEXCOORD) : SV_Target
{
#line 361
float halfHorizontalFov = tan(radians(FovAngle*0.5));
#line 363
switch(FovType)
{
#line 366
case 1: halfHorizontalFov *= rsqrt( (2160*(1.0 / 3840))* (2160*(1.0 / 3840))+1); break;
#line 368
case 2: halfHorizontalFov *=  (3840 * (1.0 / 2160)); break;
#line 370
case 3: halfHorizontalFov *= (3.0/4.0)* (3840 * (1.0 / 2160)); break;
#line 373
case 4: halfHorizontalFov *= (9.0/16.0)* (3840 * (1.0 / 2160)); break;
#line 376
}
#line 378
halfHorizontalFov = atan(halfHorizontalFov);
#line 381
float2 sphCoord = texCoord*2.0-1.0;
#line 383
sphCoord.y *=  (2160*(1.0 / 3840));
#line 385
sphCoord *= clamp(Zoom, 0.8, 1.5); 
#line 388
float2 k;
if (Expert) k = clamp(
#line 391
(AsymmetricalExpert && sphCoord.y >= 0.0)? K.xz : K.xy,
-1.0, 1.0);
else if (Manual)
{
switch (PresetKx)
{
default: k.x =  0.5; break; 
case 1:  k.x =  0.0; break; 
case 2:  k.x = -0.5; break; 
#line 401
}
switch ((AsymmetricalManual && sphCoord.y >= 0.0)? PresetKz : PresetKy)
{
default: k.y =  0.5; break; 
case 1:  k.y =  0.0; break; 
case 2:  k.y = -0.5; break; 
#line 408
}
}
else switch (SimplePresets)
{
default: k = float2( 0.0, sphCoord.y < 0.0? 0.75 :-0.5); break; 
case 1:  k = float2( 0.5, sphCoord.y < 0.0?-0.5  : 0.0); break; 
case 2:  k = float2( 0.5, 0.5); break; 
case 3:  k = float2(-0.5, 0.0); break; 
case 4:  k = float2( 0.0,-0.5); break; 
case 5:  k = float2( 0.618, 0.862); break; 
#line 419
}
#line 422
float vignetteMask = pantomorphic(halfHorizontalFov, k, sphCoord);
#line 425
sphCoord.y *=  (3840 * (1.0 / 2160));
#line 427
bool noBorder = VignettingStyle!=1 && BorderColor.a==0.0 && MirrorBorder;
#line 429
float borderMask = noBorder? 0f : BorderMaskPS(sphCoord);
#line 431
sphCoord = sphCoord*0.5+0.5;
#line 440
float3 display = tex2D(BackBuffer, sphCoord).rgb;
#line 442
if (noBorder) return vignetteMask*display;
#line 445
if (VignettingStyle==2)
return vignetteMask*lerp(
display,
lerp(
MirrorBorder? display : tex2D(BackBuffer, texCoord).rgb,
 pow(abs(BorderColor.rgb), 2.2),
 pow(abs(BorderColor.a), 2.2)
), borderMask);
else return lerp(
vignetteMask*display,
lerp(
MirrorBorder? display : tex2D(BackBuffer, texCoord).rgb,
 pow(abs(BorderColor.rgb), 2.2),
 pow(abs(BorderColor.a), 2.2)
), borderMask);
}
#line 467
technique Pantomorphic <
ui_tooltip =
"Adjust perspective for distortion-free picture\n"
"(asymmetrical anamorphic, fish-eye and vignetting)\n"
"\nManual:\n"
"Fist select proper FOV angle and type.\n"
"If FOV type is unknown, set preset to 'skating' and find a round object within the game.\n"
"look at it upfront, then rotate the camera so that the object is in the corner.\n"
"Change FOV type such that the object does not have an egg shape, but a perfect round shape.\n"
"\nSecondly adjust perspective type according to game-play style.\n"
"Thirdly, adjust visible borders. You can zoom in the picture to hide borders and reveal UI.\n"
"\nAdditionally for sharp image, use FilmicSharpen.fx or run the game at Super-Resolution.";
>
{
pass
{
VertexShader = PostProcessVS;
PixelShader = PantomorphicPS;
SRGBWriteEnable = true;
}
}

