#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Technicolor2.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Technicolor2.fx"
#line 9
uniform float3 ColorStrength <      ui_type = "color"; 
ui_tooltip = "Higher means darker and more intense colors.";
> = float3(0.2, 0.2, 0.2);
#line 13
uniform float Brightness <      ui_type = "slider"; 
ui_min = 0.5; ui_max = 1.5;
ui_tooltip = "Higher means brighter image.";
> = 1.0;
uniform float Saturation <      ui_type = "slider"; 
ui_min = 0.0; ui_max = 1.5;
ui_tooltip = "Additional saturation control since this effect tends to oversaturate the image.";
> = 1.0;
#line 22
uniform float Strength <      ui_type = "slider"; 
ui_min = 0.0; ui_max = 1.0;
ui_tooltip = "Adjust the strength of the effect.";
> = 1.0;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 27 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Technicolor2.fx"
#line 29
float3 TechnicolorPass(float4 vpos : SV_Position, float2 texcoord : TexCoord) : SV_Target
{
float3 color = saturate(tex2D(ReShade::BackBuffer, texcoord).rgb);
#line 33
float3 temp = 1.0 - color;
float3 target = temp.grg;
float3 target2 = temp.bbr;
float3 temp2 = color * target;
temp2 *= target2;
#line 39
temp = temp2 * ColorStrength;
temp2 *= Brightness;
#line 42
target = temp.grg;
target2 = temp.bbr;
#line 45
temp = color - target;
temp += temp2;
temp2 = temp - target2;
#line 49
color = lerp(color, temp2, Strength);
color = lerp(dot(color, 0.333), color, Saturation);
#line 52
return color;
}
#line 55
technique Technicolor2
{
pass
{
VertexShader = PostProcessVS;
PixelShader = TechnicolorPass;
}
}

