#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 51
uniform int UIHELP <
ui_type = "radio";
ui_label = " ";
ui_text ="This shader adds ray traced / ray marched global illumination to games\nby traversing the height field described by the depth map of the game.\n\nHover over the settings below to display more information.\n\n          >>>>>>>>>> IMPORTANT <<<<<<<<<      \n\nIf the shader appears to do nothing when enabled, make sure ReShade's\ndepth access is properly set up - no output without proper input.\n\n          >>>>>>>>>> IMPORTANT <<<<<<<<<      ";
ui_category = ">>>> OVERVIEW / HELP (click me) <<<<";
ui_category_closed = true;
>;
#line 59
uniform float RT_SAMPLE_RADIUS <
ui_type = "drag";
ui_min = 0.5; ui_max = 20.0;
ui_step = 0.01;
ui_label = "Ray Length";
ui_tooltip = "Maximum ray length, directly affects\nthe spread radius of shadows / bounce lighting";
ui_category = "Ray Tracing";
> = 4.0;
#line 68
uniform float RT_SAMPLE_RADIUS_FAR <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.01;
ui_label = "Extended Ray Length Multiplier";
ui_tooltip = "Increases ray length in the background to achieve ultra wide light bounces.";
ui_category = "Ray Tracing";
> = 0.0;
#line 77
uniform int RT_RAY_AMOUNT <
ui_type = "slider";
ui_min = 1; ui_max = 20;
ui_label = "Amount of Rays";
ui_tooltip = "Amount of rays launched per pixel in order to\nestimate the global illumination at this location.\nAmount of noise to filter is proportional to sqrt(rays).";
ui_category = "Ray Tracing";
> = 3;
#line 85
uniform int RT_RAY_STEPS <
ui_type = "slider";
ui_min = 1; ui_max = 40;
ui_label = "Amount of Steps per Ray";
ui_tooltip = "RTGI performs step-wise raymarching to check for ray hits.\nFewer steps may result in rays skipping over small details.";
ui_category = "Ray Tracing";
> = 12;
#line 93
uniform float RT_Z_THICKNESS <
ui_type = "drag";
ui_min = 0.0; ui_max = 4.0;
ui_step = 0.01;
ui_label = "Z Thickness";
ui_tooltip = "The shader can't know how thick objects are, since it only\nsees the side the camera faces and has to assume a fixed value.\n\nUse this parameter to remove halos around thin objects.";
ui_category = "Ray Tracing";
> = 0.5;
#line 102
uniform bool RT_HIGHP_LIGHT_SPREAD <
ui_label = "Enable precise light spreading";
ui_tooltip = "Rays accept scene intersections within a small error margin.\nEnabling this will snap rays to the actual hit location.\nThis results in sharper but more realistic lighting.";
ui_category = "Ray Tracing";
> = true;
#line 108
uniform bool RT_BACKFACE_MIRROR <
ui_label = "Enable simulation of backface lighting";
ui_tooltip = "RTGI can only simulate light bouncing of the objects visible on the screen.\nTo estimate light coming from non-visible sides of otherwise visible objects,\nthis feature will just take the front-side color instead.";
ui_category = "Ray Tracing";
> = false;
#line 115
uniform float RT_SPECULAR <
ui_type = "drag";
ui_min = 0.01; ui_max = 1.0;
ui_step = 0.01;
ui_label = "Specular";
ui_tooltip = "Specular Material parameter for GGX Microfacet BRDF";
ui_category = "Material";
> = 1.0;
#line 124
uniform float RT_ROUGHNESS <
ui_type = "drag";
ui_min = 0.15; ui_max = 1.0;
ui_step = 0.01;
ui_label = "Roughness";
ui_tooltip = "Roughness Material parameter for GGX Microfacet BRDF";
ui_category = "Material";
> = 1.0;
#line 137
uniform float3 SKY_COLOR <
ui_type = "color";
ui_label = "Sky Color";
ui_category = "Blending";
> = float3(1.0, 1.0, 1.0);
#line 162
uniform float SKY_COLOR_AMBIENT_MIX <
ui_type = "drag";
ui_min = 0; ui_max = 1.0;
ui_step = 0.01;
ui_label = "Sky Color Ambient Mix";
ui_tooltip = "How much of the occluded ambient color is considered skycolor\n\nIf 0, Ambient Occlusion removes white ambient color,\nif 1, Ambient Occlusion only removes skycolor";
ui_category = "Blending";
> = 0.2;
#line 171
uniform float SKY_COLOR_AMT <
ui_type = "drag";
ui_min = 0; ui_max = 10.0;
ui_step = 0.01;
ui_label = "Sky Color Intensity";
ui_category = "Blending";
> = 4.0;
#line 180
uniform float RT_AO_AMOUNT <
ui_type = "drag";
ui_min = 0; ui_max = 10.0;
ui_step = 0.01;
ui_label = "Ambient Occlusion Intensity";
ui_category = "Blending";
> = 4.0;
#line 188
uniform float RT_IL_AMOUNT <
ui_type = "drag";
ui_min = 0; ui_max = 10.0;
ui_step = 0.01;
ui_label = "Bounce Lighting Intensity";
ui_category = "Blending";
> = 4.0;
#line 197
uniform float RT_IBL_AMOUT <
ui_type = "drag";
ui_min = 0; ui_max = 1.0;
ui_step = 0.01;
ui_label = "Image Based Lighting Intensity";
ui_category = "Blending";
> = 0.0;
#line 206
uniform float RT_IL_BOUNCE_WEIGHT <
ui_type = "drag";
ui_min = 0; ui_max = 1.0;
ui_step = 0.01;
ui_label = "Next Bounce Weight";
ui_category = "Blending";
> = 0.0;
#line 215
uniform int FADEOUT_MODE_UI < 
ui_type = "slider";
ui_min = 0; ui_max = 2;
ui_label = "Fade Out Mode";
ui_category = "Blending";
> = 2;
#line 222
uniform float RT_FADE_DEPTH <
ui_type = "drag";
ui_label = "Fade Out Range";
ui_min = 0.001; ui_max = 1.0;
ui_tooltip = "Distance falloff, higher values increase RTGI draw distance.";
ui_category = "Blending";
> = 0.3;
#line 230
uniform int RT_DEBUG_VIEW <
ui_type = "radio";
ui_label = "Enable Debug View";
ui_items = "None\0Lighting Channel\0Normal Channel\0";
ui_tooltip = "Different debug outputs";
ui_category = "Debug";
> = 0;
#line 238
uniform bool RT_DO_RENDER <
ui_label = "Render a still frame (for screenshots)";
ui_category = "Experimental";
ui_tooltip = "This will progressively render a still frame. Make sure to set rays low, and steps high. \nTo start rendering, check the box and wait until the result is sufficiently noise-free.\nYou can still adjust blending and toggle debug mode, but do not touch anything else.\nTo resume the game, uncheck the box.\n\nRequires a scene with no moving objects to work properly.";
> = false;
#line 244
uniform int UIHELP2 <
ui_type = "radio";
ui_label = " ";
ui_text ="Description for preprocessor definitions:\n\nINFINITE_BOUNCES\n0: off\n1: allows the light to reflect more than once.\n\nSKYCOLOR_MODE\n0: off\n1: static color\n2: dynamic detection (wip)\n3: dynamic detection + manual tint\n\nIMAGEBASELIGHTING:\n0: off\n1: analyzes the image for main lighting directions and recovers rays that did not return data.\n\nMATERIAL_TYPE\n0: Lambertian surface (matte)\n1: GGX Material, allows to model matte, glossy, specular surfaces based off roughness and specularity parameters\n\nSMOOTHNORMALS\n0: off\n1: enables normal map filtering, reduces blockyness on low poly surfaces.";
ui_category = ">>>> PREPROCESSOR DEFINITION GUIDE (click me) <<<<";
ui_category_closed = false;
>;
#line 274
uniform uint  FRAMECOUNT  < source = "framecount"; >;
uniform float FRAMETIME   < source = "frametime";  >;
#line 295
texture ColorInputTex : COLOR;
texture DepthInputTex : DEPTH;
sampler ColorInput 	            { Texture = ColorInputTex; };
sampler DepthInput              { Texture = DepthInputTex; };
#line 300
texture ZTex                    { Width = 2560;    Height = 1440;   Format = R16F;         MipLevels = 1 +  	( ( ( ( ( ((uint(2560)>>(0))>0)+ ((uint(2560)>>(0+1))>0))+ ( ((uint(2560)>>(0+2))>0)+ ((uint(2560)>>(0+2+1))>0)))+ ( ( ((uint(2560)>>(0+4))>0)+ ((uint(2560)>>(0+4+1))>0))+ ( ((uint(2560)>>(0+4+2))>0)+ ((uint(2560)>>(0+4+2+1))>0))))+ ( ( ( ((uint(2560)>>(8))>0)+ ((uint(2560)>>(8+1))>0))+ ( ((uint(2560)>>(8+2))>0)+ ((uint(2560)>>(8+2+1))>0)))+ ( ( ((uint(2560)>>(8+4))>0)+ ((uint(2560)>>(8+4+1))>0))+ ( ((uint(2560)>>(8+4+2))>0)+ ((uint(2560)>>(8+4+2+1))>0))))) - 7); };
texture ColorTex                { Width = 2560;    Height = 1440;   Format = RGBA16F;      MipLevels = 1 +  	( ( ( ( ( ((uint(2560)>>(0))>0)+ ((uint(2560)>>(0+1))>0))+ ( ((uint(2560)>>(0+2))>0)+ ((uint(2560)>>(0+2+1))>0)))+ ( ( ((uint(2560)>>(0+4))>0)+ ((uint(2560)>>(0+4+1))>0))+ ( ((uint(2560)>>(0+4+2))>0)+ ((uint(2560)>>(0+4+2+1))>0))))+ ( ( ( ((uint(2560)>>(8))>0)+ ((uint(2560)>>(8+1))>0))+ ( ((uint(2560)>>(8+2))>0)+ ((uint(2560)>>(8+2+1))>0)))+ ( ( ((uint(2560)>>(8+4))>0)+ ((uint(2560)>>(8+4+1))>0))+ ( ((uint(2560)>>(8+4+2))>0)+ ((uint(2560)>>(8+4+2+1))>0))))) - 7); };
texture GITex                   { Width = 2560;    Height = 1440;   Format = RGBA16F;      MipLevels = 4; };
texture GITexFrame1             { Width = 2560;    Height = 1440;   Format = RGBA16F;      MipLevels = 4;    };
texture GITexFrame2             { Width = 2560;    Height = 1440;   Format = RGBA16F;      MipLevels = 4;    };
texture GITexFrame3             { Width = 2560;    Height = 1440;   Format = RGBA16F;      MipLevels = 4;    };
texture GITexFilter1            { Width = 2560;    Height = 1440;   Format = RGBA16F;     };
texture GITexFilter0            { Width = 2560;    Height = 1440;   Format = RGBA16F;     }; 
texture GBufferTex              { Width = 2560;    Height = 1440;   Format = RGBA16F;     };
texture GBufferTexFrame1        { Width = 2560;    Height = 1440;   Format = RGBA16F;     };
texture GBufferTexFrame2        { Width = 2560;    Height = 1440;   Format = RGBA16F;     };
texture GBufferTexFrame3        { Width = 2560;    Height = 1440;   Format = RGBA16F;     };
#line 313
sampler sZTex	            	{ Texture = ZTex; };
sampler sColorTex	        	{ Texture = ColorTex; };
sampler sGITex	                { Texture = GITex; 	};
sampler sGITexFilter1	        { Texture = GITexFilter1; };
sampler sGITexFilter0	        { Texture = GITexFilter0; };
sampler sGBufferTex	            { Texture = GBufferTex;	};
sampler sGITexFrame1	        { Texture = GITexFrame1;	};
sampler sGITexFrame2	        { Texture = GITexFrame2;	};
sampler sGITexFrame3	        { Texture = GITexFrame3;	};
sampler sGBufferTexFrame1	    { Texture = GBufferTexFrame1;	};
sampler sGBufferTexFrame2	    { Texture = GBufferTexFrame2;	};
sampler sGBufferTexFrame3	    { Texture = GBufferTexFrame3;	};
#line 326
texture JitterTex < source = "bluenoise.png"; > { Width = 32; 			  Height = 32; 				Format = RGBA8; };
sampler	sJitterTex          					{ Texture = JitterTex; AddressU = WRAP; AddressV = WRAP;};
#line 330
texture ProbeTex      					        { Width = 64;   Height = 64;  Format = RGBA16F;};
sampler sProbeTex	    					    { Texture = ProbeTex;	};
texture ProbeTexPrev      					    { Width = 64;   Height = 64;  Format = RGBA16F;};
sampler sProbeTexPrev	    					{ Texture = ProbeTexPrev;	};
#line 336
struct VSOUT
{
float4 vpos : SV_Position;
float2 uv   : TEXCOORD0;
};
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Global.fxh"
#line 19
void VS_FullscreenTriangle(in uint id : SV_VertexID, out float4 vpos : SV_Position, out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
vpos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 26
struct MRT2
{
float4 t0 : SV_Target0;
float4 t1 : SV_Target1;
};
#line 32
struct MRT3
{
float4 t0 : SV_Target0;
float4 t1 : SV_Target1;
float4 t2 : SV_Target2;
};
#line 39
struct MRT4
{
float4 t0 : SV_Target0;
float4 t1 : SV_Target1;
float4 t2 : SV_Target2;
float4 t3 : SV_Target3;
};
#line 50
float4 tex2Dlod(sampler i, float2 uv, float mip)
{
return tex2Dlod(i, float4(uv, 0, mip));
}
#line 342 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Depth.fxh"
#line 52
namespace Depth
{
#line 55
float2 correct_uv(float2 uv)
{
#line 60
uv /= float2(                 1,                  1);
#line 64
uv.x -=                 0    / 2.000000001;
#line 69
uv.y +=                 0    / 2.000000001;
#line 71
return uv;
}
#line 74
float linearize_depth(float depth)
{
depth *=                     1	;
#line 82
depth = 1.0 - depth;
#line 84
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
return saturate(depth);
}
#line 89
float4 linearize_depths(float4 depths)
{
depths *=                     1	;
#line 97
depths = 1.0 - depths;
#line 99
const float N = 1.0;
depths /= 1000.0 - depths * (1000.0 - N);
return saturate(depths);
}
#line 104
float get_depth(float2 uv)
{
return tex2Dlod(DepthInput, float4(correct_uv(uv), 0, 0)).x;
}
#line 109
float get_linear_depth(float2 uv)
{
float depth = get_depth(uv);
depth = linearize_depth(depth);
return depth;
}
#line 116
} 
#line 343 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Projection.fxh"
#line 23
namespace Projection
{
#line 26
float depth_to_z(in float depth)
{
return depth * 1000.0 + 1.0;
}
#line 31
float z_to_depth(in float z)
{
return (z - 1.0) * rcp(1000.0);
}
#line 36
float2 proj_to_uv(in float3 pos)
{
#line 39
const float3 uvtoprojADD = float3(-tan(radians( 60.0) * 0.5).xx, 1.0) *      float2(1.0, 2560 * (1.0 / 1440)).yxx;
const float3 uvtoprojMUL = float3(-2.0 * uvtoprojADD.xy, 0.0);
#line 42
const float4 projtouv = float4(rcp(uvtoprojMUL.xy), -rcp(uvtoprojMUL.xy) * uvtoprojADD.xy);
return (pos.xy / pos.z) * projtouv.xy + projtouv.zw;
}
#line 46
float3 uv_to_proj(float2 uv, float z)
{
#line 49
const float3 uvtoprojADD = float3(-tan(radians( 60.0) * 0.5).xx, 1.0) *      float2(1.0, 2560 * (1.0 / 1440)).yxx;
const float3 uvtoprojMUL = float3(-2.0 * uvtoprojADD.xy, 0.0);
#line 52
return (uv.xyx * uvtoprojMUL + uvtoprojADD) * z;
}
#line 55
float3 uv_to_proj(in float2 uv)
{
float z = depth_to_z(Depth::get_linear_depth(uv));
return uv_to_proj(uv, z);
}
#line 61
float3 uv_to_proj(in float2 uv, sampler2D ztex, in int mip)
{
float z = tex2Dlod(ztex, float4(uv.xyx, mip)).x;
return uv_to_proj(uv, z);
}
#line 67
} 
#line 344 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Normal.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Projection.fxh"
#line 14 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Normal.fxh"
#line 16
namespace Normal
{
#line 22
float3 normal_from_depth(in float2 uv)
{
float3 center_position = Projection::uv_to_proj(uv);
#line 26
float3 delta_x, delta_y;
float4 neighbour_uv;
#line 29
neighbour_uv = uv.xyxy + float4(       float2((1.0 / 2560), (1.0 / 1440)).x, 0, -       float2((1.0 / 2560), (1.0 / 1440)).x, 0);
#line 31
float3 delta_right = Projection::uv_to_proj(neighbour_uv.xy) - center_position;
float3 delta_left  = center_position - Projection::uv_to_proj(neighbour_uv.zw);
#line 34
delta_x = abs(delta_right.z) > abs(delta_left.z) ? delta_left : delta_right;
#line 36
neighbour_uv = uv.xyxy + float4(0,        float2((1.0 / 2560), (1.0 / 1440)).y, 0, -       float2((1.0 / 2560), (1.0 / 1440)).y);
#line 38
float3 delta_bottom = Projection::uv_to_proj(neighbour_uv.xy) - center_position;
float3 delta_top  = center_position - Projection::uv_to_proj(neighbour_uv.zw);
#line 41
delta_y = abs(delta_bottom.z) > abs(delta_top.z) ? delta_top : delta_bottom;
#line 43
float3 normal = cross(delta_y, delta_x);
normal *= rsqrt(dot(normal, normal)); 
#line 46
return normal;
}
#line 49
float3x3 base_from_vector(float3 n)
{
#line 52
bool bestside = n.z < n.y;
#line 54
float3 n2 = bestside ? n.xzy : n;
#line 56
float3 k = (-n2.xxy * n2.xyy) * rcp(1.0 + n2.z) + float3(1, 0, 1);
float3 u = float3(k.xy, -n2.x);
float3 v = float3(k.yz, -n2.y);
#line 60
u = bestside ? u.xzy : u;
v = bestside ? v.xzy : v;
#line 63
return float3x3(u, v, n);
}
#line 66
} 
#line 345 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Random.fxh"
#line 16
namespace Random
{
#line 19
float goldenweyl1(float n)
{
return frac(0.5 + n * 0.6180339887498);
}
#line 24
float goldenweyl1(float n, float x)
{
return frac(x + n * 0.6180339887498);
}
#line 29
float2 goldenweyl2(float n)
{
return frac(0.5 + n * float2(0.7548776662467, 0.569840290998));
}
#line 34
float2 goldenweyl2(float n, float2 x)
{
return frac(x + n * float2(0.7548776662467, 0.569840290998));
}
#line 39
float3 goldenweyl3(float n)
{
return frac(0.5 + n * float3(0.8191725133961, 0.6710436067038, 0.5497004779019));
}
#line 44
float3 goldenweyl3(float n, float3 x)
{
return frac(x + n * float3(0.8191725133961, 0.6710436067038, 0.5497004779019));
}
#line 49
} 
#line 346 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\RayTracing.fxh"
#line 14
namespace RayTracing
{
#line 17
struct RayDesc
{
float3 origin;
float3 pos;
float3 dir;
float2 uv;
float length;
float width; 
};
#line 27
float compute_intersection(inout RayDesc ray, float maxT, float incT, float epsilon, bool snap_intersection)
{
float intersected = 0;
#line 31
float2 uv = ray.uv;
float4 prev = float4(ray.origin, 0);
float2 prevuv = uv;
#line 35
[loop]
while(ray.length < maxT)
{
float lambda = ray.length / maxT;
lambda = lambda * (lambda * (1.25 * lambda - 0.375) + 0.125);
#line 41
ray.pos = ray.origin + ray.dir * lambda * maxT;
ray.uv = Projection::proj_to_uv(ray.pos);
#line 44
if(!all(saturate(-ray.uv * ray.uv + ray.uv))) break;
#line 46
float2 pixel_delta_total =       uint2(2560, 1440) * abs(ray.uv - uv);
float2 pixel_delta_step  =       uint2(2560, 1440) * abs(ray.uv - prevuv);
ray.width = log2(max(length(pixel_delta_total) * 0.0625, max(pixel_delta_step.x, pixel_delta_step.y) * 0.2));
#line 51
ray.width = min(ray.width,  	( ( ( ( ( ((uint(2560)>>(0))>0)+ ((uint(2560)>>(0+1))>0))+ ( ((uint(2560)>>(0+2))>0)+ ((uint(2560)>>(0+2+1))>0)))+ ( ( ((uint(2560)>>(0+4))>0)+ ((uint(2560)>>(0+4+1))>0))+ ( ((uint(2560)>>(0+4+2))>0)+ ((uint(2560)>>(0+4+2+1))>0))))+ ( ( ( ((uint(2560)>>(8))>0)+ ((uint(2560)>>(8+1))>0))+ ( ((uint(2560)>>(8+2))>0)+ ((uint(2560)>>(8+2+1))>0)))+ ( ( ((uint(2560)>>(8+4))>0)+ ((uint(2560)>>(8+4+1))>0))+ ( ((uint(2560)>>(8+4+2))>0)+ ((uint(2560)>>(8+4+2+1))>0))))) - 7) - saturate(1 - RT_ROUGHNESS * 2.0) * 3);
#line 56
float3 pos = Projection::uv_to_proj(ray.uv, sZTex, ray.width);
float delta = pos.z - ray.pos.z;
#line 59
float z_tolerance = epsilon * maxT;
z_tolerance *= lerp(0.2, 10.0, lambda);
z_tolerance *= abs(ray.dir.z);
#line 63
[branch]
if(abs(delta * 2.0 + z_tolerance) < z_tolerance)
{
intersected = saturate(1 - lambda);
ray.uv = prev.w < 0 ? ray.uv : Projection::proj_to_uv(lerp(prev.xyz, ray.pos, prev.w / (prev.w + abs(delta))));
if(snap_intersection)
ray.dir = normalize(lerp(pos - ray.origin, ray.dir, saturate(0.111 * maxT * lambda)));
break;
}
#line 73
ray.length += incT;
prev = float4(ray.pos, delta);
prevuv = ray.uv;
}
#line 78
return saturate(intersected);
}
#line 81
} 
#line 347 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT\Denoise.fxh"
#line 14
namespace Denoise
{
#line 17
struct FilterSample
{
float4 gbuffer;
float4 val;
};
#line 23
FilterSample fetch_sample(in float2 uv, sampler gi)
{
FilterSample o;
o.gbuffer = tex2Dlod(sGBufferTex, uv, 0);
o.val     = tex2Dlod(gi, uv, 0);
return o;
}
#line 31
float3 unpack_hdr(float3 color)
{
color  = saturate(color);
#line 35
color = color * rcp(1.04 - saturate(color));
return color;
}
#line 39
float3 pack_hdr(float3 color)
{
color =  1.04 * color * rcp(color + 1.0);
color  = saturate(color);
#line 44
return color;
}
#line 47
float4 atrous(in VSOUT i, in sampler gi, int iteration, int mode)
{
FilterSample center = fetch_sample(i.uv, gi);
#line 51
if(mode < 0) 
return center.val;
#line 54
float4 value_sum = center.val * 0.01;
float4 weight_sum = 0.01;
#line 57
float4 kernel = float4(1.5,3.5,7,15);
float4 sigma_z = float4(0.7,0.7,0.7,0.7);
float4 sigma_n = float4(0.75,1.5,1.5,5);
float4 sigma_v = float4(0.035,0.6,1.4,5);
#line 62
if(mode == 1)
{
sigma_z *= 4;
sigma_n *= 10;
sigma_v *= 64;
}
#line 69
float expectederror = sqrt(RT_RAY_AMOUNT);
#line 71
for(float x = -1; x <= 1; x++)
for(float y = -1; y <= 1; y++)
{
float2 uv = i.uv + float2(x, y) * kernel[iteration] *        float2((1.0 / 2560), (1.0 / 1440));
FilterSample tap = fetch_sample(uv, gi);
#line 77
float wz = sigma_z[iteration] * 16.0 *  (1.0 - tap.gbuffer.w / center.gbuffer.w);
wz = saturate(0.5 - lerp(wz, abs(wz), 0.75));
#line 80
float wn = saturate(dot(tap.gbuffer.xyz, center.gbuffer.xyz) * (sigma_n[iteration] + 1) - sigma_n[iteration]);
wn = lerp(wn, 1, saturate(wz * 1.42 - 0.42));
#line 83
float4 wi;
wi.rgb = dot(abs(pack_hdr(tap.val.rgb) - pack_hdr(center.val.rgb)), float3(0.3, 0.59, 0.11));
wi.w = abs(tap.val.w - center.val.w);
wi = rcp(1 + wi * wi * float4(20, 20, 20, 180) * sigma_v[iteration] * expectederror);
#line 88
float4 w = saturate(wz * wn * wi);
#line 90
value_sum += tap.val * w;
weight_sum += w;
}
#line 94
float4 result = value_sum / weight_sum;
return result;
}
#line 98
} 
#line 348 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\qUINT_rtgi.fx"
#line 354
float3 unpack_hdr(float3 color)
{
color  = saturate(color);
#line 358
color = color * rcp(1.03 - saturate(color));
return color;
}
#line 362
float3 pack_hdr(float3 color)
{
color =  1.03 * color * rcp(color + 1.0);
color  = saturate(color);
#line 367
return color;
}
#line 370
float3 ggx_vndf(float2 uniform_disc, float2 alpha, float3 v)
{
#line 373
float3 Vh = normalize(float3(alpha * v.xy, v.z));
#line 375
float2 p = uniform_disc;
p.y = lerp(sqrt(1.0 - p.x*p.x),
p.y,
Vh.z * 0.5 + 0.5);
#line 380
float3 Nh =  float3(p.xy, sqrt(saturate(1.0 - dot(p, p)))); 
#line 383
Nh = mul(Nh, Normal::base_from_vector(Vh));
#line 386
Nh = normalize(float3(alpha * Nh.xy, saturate(Nh.z)));
#line 388
return Nh;
}
#line 391
float3 schlick_fresnel(float vdoth, float3 f0)
{
vdoth = saturate(vdoth);
return lerp(pow(vdoth, 5), 1, f0);
}
#line 397
float ggx_g2_g1(float3 l, float3 v, float2 alpha)
{
#line 400
l.xy *= alpha;
v.xy *= alpha;
float nl = length(l);
float nv = length(v);
#line 405
float ln = l.z * nv;
float lv = l.z * v.z;
float vn = v.z * nl;
#line 409
return (ln + lv) / (vn + ln + 1e-7);
}
#line 412
float3 dither(in VSOUT i)
{
const float2 magicdot = float2(0.75487766624669276, 0.569840290998);
const float3 magicadd = float3(0, 0.025, 0.0125) * dot(magicdot, 1);
#line 417
const int bit_depth = 8; 
const float lsb = exp2(bit_depth) - 1;
#line 420
float3 dither = frac(dot(i.vpos.xy, magicdot) + magicadd);
dither /= lsb;
#line 423
return dither;
}
#line 426
float fade_distance(in VSOUT i)
{
float distance = saturate(length(Projection::uv_to_proj(i.uv)) / 1000.0);
float fade;
switch(FADEOUT_MODE_UI)
{
case 0:
fade = saturate((RT_FADE_DEPTH - distance) / RT_FADE_DEPTH);
break;
case 1:
fade = saturate((RT_FADE_DEPTH - distance) / RT_FADE_DEPTH);
fade *= fade; fade *= fade;
break;
case 2:
float fadefact = rcp(RT_FADE_DEPTH * 0.32);
float cutoff = exp(-fadefact);
fade = saturate((exp(-distance * fadefact) - cutoff)/(1 - cutoff));
break;
}
#line 446
return fade;
}
#line 453
VSOUT VS_RT(in uint id : SV_VertexID)
{
VSOUT o;
VS_FullscreenTriangle(id, o.vpos, o.uv); 
return o;
}
#line 460
void PS_InputSetup(in VSOUT i, out MRT3 o)
{
float depth = Depth::get_linear_depth(i.uv);
float3 n    = Normal::normal_from_depth(i.uv);
float3 col  = tex2D(ColorInput, i.uv).rgb;
#line 466
o.t0 = float4(unpack_hdr(col), depth < 0.999); 
o.t1 = Projection::depth_to_z(depth);
o.t2 = float4(n, o.t1.x);
}
#line 471
void PS_Smoothnormals(in VSOUT i, out float4 gbuffer : SV_Target0)
{
const float max_n_n = 0.63;
const float max_v_s = 0.65;
const float max_c_p = 0.5;
const float searchsize = 0.0125;
const int dirs = 5;
#line 479
float4 gbuf_center = tex2D(sGITexFilter0, i.uv);
#line 481
float3 n_center = gbuf_center.xyz;
float3 p_center = Projection::uv_to_proj(i.uv, gbuf_center.w);
float radius = searchsize + searchsize * rcp(p_center.z) * 2.0;
float worldradius = radius * p_center.z;
#line 486
int steps = clamp(ceil(radius * 300.0) + 1, 1, 7);
float3 n_sum = 0.001 * n_center;
#line 489
for(float j = 0; j < dirs; j++)
{
float2 dir; sincos(radians(360.0 * j / dirs + 0.666), dir.y, dir.x);
#line 493
float3 n_candidate = n_center;
float3 p_prev = p_center;
#line 496
for(float stp = 1.0; stp <= steps; stp++)
{
float fi = stp / steps;
fi *= fi * rsqrt(fi);
#line 501
float offs = fi * radius;
offs += length(       float2((1.0 / 2560), (1.0 / 1440)));
#line 504
float2 uv = i.uv + dir * offs *      float2(1.0, 2560 * (1.0 / 1440));
if(!all(saturate(uv - uv*uv))) break;
#line 507
float4 gbuf = tex2Dlod(sGITexFilter0, uv, 0);
float3 n = gbuf.xyz;
float3 p = Projection::uv_to_proj(uv, gbuf.w);
#line 511
float3 v_increment  = normalize(p - p_prev);
#line 513
float ndotn         = dot(n, n_center);
float vdotn         = dot(v_increment, n_center);
float v2dotn        = dot(normalize(p - p_center), n_center);
#line 517
ndotn *= max(0, 1.0 + fi *0.5 * (1.0 - abs(v2dotn)));
#line 519
if(abs(vdotn)  > max_v_s || abs(v2dotn) > max_c_p) break;
#line 521
if(ndotn > max_n_n)
{
float d = distance(p, p_center) / worldradius;
float w = saturate(4.0 - 2.0 * d) * smoothstep(max_n_n, lerp(max_n_n, 1.0, 2), ndotn); 
w = stp < 1.5 && d < 2.0 ? 1 : w;  
n_candidate = lerp(n_candidate, n, w);
n_candidate = normalize(n_candidate);
}
#line 530
p_prev = p;
n_sum += n_candidate;
}
}
#line 535
n_sum = normalize(n_sum);
gbuffer = float4(n_sum, gbuf_center.w);
}
#line 540
void PS_Copy23(in VSOUT i, out MRT2 o)
{
o.t0 = tex2D(sGITexFrame2, i.uv);
o.t1 = tex2D(sGBufferTexFrame2, i.uv);
}
#line 546
void PS_Copy12(in VSOUT i, out MRT2 o)
{
o.t0 = tex2D(sGITexFrame1, i.uv);
o.t1 = tex2D(sGBufferTexFrame1, i.uv);
}
#line 552
void PS_Copy01(in VSOUT i, out MRT2 o)
{
o.t0 = tex2D(sGITex, i.uv);
o.t1 = tex2D(sGBufferTex, i.uv);
}
#line 558
void PS_RTGI(in VSOUT i, out float4 o : SV_Target0)
{
float3 jitter =               tex2Dfetch(sJitterTex,  i.vpos.xy 	   % 32u).xyz;
jitter = frac(jitter + tex2Dfetch(sJitterTex, (i.vpos.xy / 32)  % 32u).xyz);
#line 563
float3 n = tex2D(sGBufferTex, i.uv).xyz;
#line 565
float3 p = Projection::uv_to_proj(i.uv); 
float d = Projection::z_to_depth(p.z); p *= 0.999; p += n * d;
#line 568
float ray_maxT = RT_SAMPLE_RADIUS * RT_SAMPLE_RADIUS;
ray_maxT *= lerp(1.0, 100.0, saturate(d * RT_SAMPLE_RADIUS_FAR));
ray_maxT = min(ray_maxT, 1000.0);
#line 573
float3 specular_color = tex2D(ColorInput, i.uv).rgb;
specular_color = lerp(dot(specular_color, 0.333), specular_color, 0.666);
specular_color *= RT_SPECULAR * 2.0;
float3 eyedir = -normalize(p);
float3x3 tangent_base = Normal::base_from_vector(n);
float3 tangent_eyedir = mul(eyedir, transpose(tangent_base));
#line 581
int nrays  = RT_DO_RENDER ? 1   : RT_RAY_AMOUNT;
int nsteps = RT_DO_RENDER ? 100 : RT_RAY_STEPS;
#line 584
o = 0;
#line 586
[loop]
for(int r = 0; r < 0 + nrays; r++)
{
RayTracing::RayDesc ray;
float3 r3 = Random::goldenweyl3(r * 4 + (FRAMECOUNT % 4), jitter);
#line 592
[branch]
if(RT_DO_RENDER)
r3 = Random::goldenweyl3(r *    1500 + (FRAMECOUNT %    1500), jitter);
#line 603
float alpha = RT_ROUGHNESS * RT_ROUGHNESS; 
#line 605
float2 uniform_disc;
sincos(r3.x * 3.1415927 * 2,  uniform_disc.y,  uniform_disc.x);
uniform_disc *= sqrt(r3.y);
float3 v = tangent_eyedir;
float3 h = ggx_vndf(uniform_disc, alpha.xx, v);
float3 l = reflect(-v, h);
#line 613
float3 brdf = ggx_g2_g1(l, v , alpha.xx); 
brdf = l.z < 1e-7 ? 0 : brdf; 
float vdoth = dot(eyedir, h);
brdf *= schlick_fresnel(vdoth, specular_color);
#line 618
ray.dir = mul(l, tangent_base); 
#line 620
if (dot(ray.dir, n) < 0.02) continue;
#line 622
float ray_incT = (ray_maxT / nsteps) * rsqrt(saturate(1.0 - ray.dir.z * ray.dir.z));
#line 624
ray.length = ray_incT * r3.z;
ray.origin = p;
ray.uv = i.uv;
#line 628
float intersected = RayTracing::compute_intersection(ray, ray_maxT, ray_incT, RT_Z_THICKNESS * RT_Z_THICKNESS, RT_HIGHP_LIGHT_SPREAD);
#line 630
[branch]
if(RT_IL_AMOUNT * intersected < 0.05)
{
o.w += intersected;
#line 635
float4 probe = tex2Dlod(sProbeTex, ray.dir.xy * 0.5 + 0.5, 0);  unpack_hdr(probe.rgb);
o += probe * RT_IBL_AMOUT;
#line 638
continue;
}
else
{
#line 644
ray.width *= smoothstep(0.05, 0.3, RT_ROUGHNESS);
#line 646
float4 albedofetch      = tex2Dlod(sColorTex,   ray.uv, ray.width);
float3 albedo = albedofetch.rgb * albedofetch.a; 
float3 intersect_normal = tex2Dlod(sGBufferTex, ray.uv, 0).xyz;
albedo *= lerp(RT_BACKFACE_MIRROR ? 0.2 : 0, 1, saturate(dot(-intersect_normal, ray.dir) * 64.0));
#line 652
albedo *= brdf;
albedo *= 10.0;
#line 656
float4 nextbounce = tex2Dlod(sGITexFilter1, ray.uv, ray.width);
float3 compounded = normalize(albedo+0.1) * nextbounce.rgb;
albedo += compounded * RT_IL_BOUNCE_WEIGHT;
#line 661
o += float4(albedo * intersected, intersected);
}
}
#line 665
o /= nrays;
#line 671
if(!RT_DO_RENDER)
{
 o.w = max(i.vpos.x, i.vpos.y) <= 1.0 ? 0 : o.w;;
}
else
{
float counter =  tex2Dfetch(sGITexFrame1, 0).w;
float4 last_accumulated = tex2D(sGITexFrame1, i.uv);
unpack_hdr(last_accumulated.rgb);
#line 683
if(counter <    1500)
{
counter++;
o = lerp(last_accumulated, o, rcp(counter));
}
else
{
o = last_accumulated;
}
 o.w = max(i.vpos.x, i.vpos.y) <= 1.0 ? counter : o.w;;
}
}
#line 696
void PS_Merge0123(in VSOUT i, out float4 o : SV_Target0)
{
if(RT_DO_RENDER)
{
o = tex2D(sGITex, i.uv);
return;
}
float4 gbuf[4];
gbuf[0] = tex2D(sGBufferTex, i.uv);
gbuf[1] = tex2D(sGBufferTexFrame1, i.uv);
gbuf[2] = tex2D(sGBufferTexFrame2, i.uv);
gbuf[3] = tex2D(sGBufferTexFrame3, i.uv);
#line 709
float4 weights = 1.0;
#line 711
[unroll]
for(int j = 1; j < 4; j++)
{
float4 delta = abs(gbuf[0] - gbuf[j]);
const float normal_sensitivity = 2.0;
const float z_sensitivity = 1.0;
delta /= max(FRAMETIME, 1.0) / 16.7; 
float d = dot(delta, float4(delta.xyz * normal_sensitivity, z_sensitivity)); 
float w = saturate(exp(-d));
weights[j] = w;
}
#line 723
float sumweight = dot(weights, 1);
float historyweight = sumweight - 1;
#line 726
float mip = max(0, 3.0 - historyweight);
#line 728
float4 combined = tex2Dlod(sGITex,       i.uv, mip) * weights.x
+ tex2Dlod(sGITexFrame1, i.uv, mip) * weights.y
+ tex2Dlod(sGITexFrame2, i.uv, mip) * weights.z
+ tex2Dlod(sGITexFrame3, i.uv, mip) * weights.w;
o = combined / sumweight;
}
#line 735
void PS_Filter0(in VSOUT i, out float4 o : SV_Target0) {     o = Denoise::atrous(i, sGITexFilter1, 0, RT_DO_RENDER -       0 * 2); }
void PS_Filter1(in VSOUT i, out float4 o : SV_Target0) {     o = Denoise::atrous(i, sGITexFilter0, 1, RT_DO_RENDER -       0 * 2); }
void PS_Filter2(in VSOUT i, out float4 o : SV_Target0) {     o = Denoise::atrous(i, sGITexFilter1, 2, RT_DO_RENDER -       0 * 2); }
void PS_Filter3(in VSOUT i, out float4 o : SV_Target0) {     o = Denoise::atrous(i, sGITexFilter0, 3, RT_DO_RENDER -       0 * 2); }
#line 740
void PS_Display(in VSOUT i, out float4 o : SV_Target0)
{
float4 gi = tex2D(sGITexFilter1, i.uv);
float3 color = tex2D(ColorInput, i.uv).rgb;
#line 745
color = unpack_hdr(color);
#line 747
color = RT_DEBUG_VIEW == 1 ? 0.8 : color;
#line 749
float fade = fade_distance(i);
gi *= fade;
#line 754
float3 skycol = SKY_COLOR;
#line 762
skycol *= fade;
#line 764
color += color * gi.rgb * RT_IL_AMOUNT * RT_IL_AMOUNT; 
color = color / (1.0 + lerp(1.0, skycol, SKY_COLOR_AMBIENT_MIX) * gi.w * RT_AO_AMOUNT); 
color = color * (1.0 + skycol * SKY_COLOR_AMT);
#line 772
color = pack_hdr(color);
#line 775
color += dither(i);
#line 777
color = RT_DEBUG_VIEW == 2 ? tex2D(sGBufferTex, i.uv).xyz * float3(0.5, 0.5, -0.5) + 0.5 : color;
o = float4(color, 1);
}
#line 782
void PS_Probe(in VSOUT i, out float4 o : SV_Target0)
{
float3 n;
n.xy = i.uv * 2.0 - 1.0;
n.z  = sqrt(saturate(1.0 - dot(n.xy, n.xy)));
#line 788
bool probe = length(n.xy) < 1.3; 
#line 790
uint2 kernel_spatial   = uint2(32 *      float2(1.0, 2560 * (1.0 / 1440)).yx);
uint kernel_temporal   = 64;
uint frame_num         = FRAMECOUNT;
float2 grid_increment   = rcp(kernel_spatial); 
float2 grid_start      = Random::goldenweyl2(frame_num % kernel_temporal) * grid_increment;
float2 grid_pos        = grid_start;
#line 797
float4 probe_light = 0;
float4 sky_light   = 0;
#line 800
float wsum = 0.00001;
#line 802
for(int x = 0; x < kernel_spatial.x; x++)
{
for(int y = 0; y < kernel_spatial.y; y++)
{
float4 tapg = tex2Dlod(sGBufferTex, grid_pos, 0);
float3 tapc = tex2Dlod(sColorTex, grid_pos, 2).rgb;
#line 809
tapg.a = Projection::z_to_depth(tapg.a);
#line 811
float similarity = saturate(dot(tapg.xyz, -n)); 
bool issky = tapg.a > 0.999;
#line 814
float3 tap_sdr = pack_hdr(tapc);
#line 816
sky_light   += float4(tap_sdr, 1) * issky;
probe_light += float4(tapc, 1) * tapg.a * probe * similarity  * !issky;
wsum += tapg.a * probe;
grid_pos.y += grid_increment.y;
}
grid_pos.y = grid_start.y;
grid_pos.x += grid_increment.x;
}
#line 825
probe_light /= wsum;
sky_light.rgb   /= sky_light.a + 1e-3;
#line 828
float4 prev_probe = tex2D(sProbeTexPrev, i.uv);
#line 830
o = 0;
if(probe) 
{
o = lerp(prev_probe, probe_light, 0.02);
o = saturate(o);
}
else
{
bool skydetectedthisframe = sky_light.w > 0.000001;
bool skydetectedatall = prev_probe.w;
#line 841
float h = 0;
#line 843
if(skydetectedthisframe)
h = skydetectedatall ? saturate(0.1 * 0.01 * FRAMETIME) : 1;
#line 846
o.rgb = lerp(prev_probe.rgb, sky_light.rgb, h);
o.w = skydetectedthisframe || skydetectedatall;
}
}
#line 851
void PS_CopyProbe(in VSOUT i, out float4 o : SV_Target0)
{
o = tex2D(sProbeTex, i.uv);
}
#line 861
technique RTGlobalIllumination
< ui_tooltip = "              >> qUINT::RTGI 0.26 <<\n\n"
"         EARLY ACCESS -- PATREON ONLY\n"
"Official versions only via patreon.com/mcflypg\n"
"\nRTGI is written by Pascal Gilcher (Marty McFly) \n"
"Early access, featureset might be subject to change"; >
{
#line 869
pass{ VertexShader = VS_RT; PixelShader  = PS_Probe;        RenderTarget = ProbeTex;                                                                                        }
pass{ VertexShader = VS_RT; PixelShader  = PS_CopyProbe;    RenderTarget = ProbeTexPrev;                                                                                    }
#line 872
pass{ VertexShader = VS_RT; PixelShader = PS_Copy23;         RenderTarget0 = GITexFrame3;   RenderTarget1 = GBufferTexFrame3;                                               }
pass{ VertexShader = VS_RT; PixelShader = PS_Copy12;         RenderTarget0 = GITexFrame2;   RenderTarget1 = GBufferTexFrame2;                                               }
pass{ VertexShader = VS_RT; PixelShader = PS_Copy01;         RenderTarget0 = GITexFrame1;   RenderTarget1 = GBufferTexFrame1;                                               }
#line 879
pass{ VertexShader = VS_RT; PixelShader = PS_InputSetup;     RenderTarget0 = ColorTex;    RenderTarget1 = ZTex;      RenderTarget2 = GBufferTex;                            }
#line 882
pass{ VertexShader = VS_RT; PixelShader = PS_RTGI;           RenderTarget0 = GITex;                                                                                         }
pass{ VertexShader = VS_RT; PixelShader = PS_Merge0123;      RenderTarget0 = GITexFilter1;                                                                                  }
pass{ VertexShader = VS_RT; PixelShader = PS_Filter0;        RenderTarget0 = GITexFilter0;                                                                                  }
pass{ VertexShader = VS_RT; PixelShader = PS_Filter1;        RenderTarget0 = GITexFilter1;                                                                                  }
pass{ VertexShader = VS_RT; PixelShader = PS_Filter2;        RenderTarget0 = GITexFilter0;                                                                                  }
pass{ VertexShader = VS_RT; PixelShader = PS_Filter3;        RenderTarget0 = GITexFilter1;                                                                                  }
pass{ VertexShader = VS_RT; PixelShader = PS_Display;                                                                                                                       }
}

