#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\GaussianBlur.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\GaussianBlur.fx"
#line 9
uniform int GaussianBlurRadius <        ui_type = "slider"; 
ui_min = 0; ui_max = 4;
ui_tooltip = "[0|1|2|3|4] Adjusts the blur radius. Higher values increase the radius";
> = 1;
#line 14
uniform float GaussianBlurOffset <      ui_type = "slider"; 
ui_min = 0.00; ui_max = 1.00;
ui_tooltip = "Additional adjustment for the blur radius. Values less than 1.00 will reduce the radius.";
> = 1.00;
#line 19
uniform float GaussianBlurStrength <      ui_type = "slider"; 
ui_min = 0.00; ui_max = 1.00;
ui_tooltip = "Adjusts the strength of the effect.";
> = 0.300;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 24 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\GaussianBlur.fx"
#line 26
texture GaussianBlurTex < pooled = true; > { Width = 2560; Height = 1440; Format = RGBA8; };
sampler GaussianBlurSampler { Texture = GaussianBlurTex;};
#line 29
float3 GaussianBlurFinal(in float4 pos : SV_Position, in float2 texcoord : TEXCOORD) : COLOR
{
#line 32
float3 color = tex2D(GaussianBlurSampler, texcoord).rgb;
#line 34
if(GaussianBlurRadius == 0)
{
float offset[4] = { 0.0, 1.1824255238, 3.0293122308, 5.0040701377 };
float weight[4] = { 0.39894, 0.2959599993, 0.0045656525, 0.00000149278686458842 };
#line 39
color *= weight[0];
#line 41
[loop]
for(int i = 1; i < 4; ++i)
{
color += tex2D(GaussianBlurSampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(GaussianBlurSampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 49
if(GaussianBlurRadius == 1)
{
float offset[6] = { 0.0, 1.4584295168, 3.40398480678, 5.3518057801, 7.302940716, 9.2581597095 };
float weight[6] = { 0.13298, 0.23227575, 0.1353261595, 0.0511557427, 0.01253922, 0.0019913644 };
#line 54
color *= weight[0];
#line 56
[loop]
for(int i = 1; i < 6; ++i)
{
color += tex2D(GaussianBlurSampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(GaussianBlurSampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 64
if(GaussianBlurRadius == 2)
{
float offset[11] = { 0.0, 1.4895848401, 3.4757135714, 5.4618796741, 7.4481042327, 9.4344079746, 11.420811147, 13.4073334, 15.3939936778, 17.3808101174, 19.3677999584 };
float weight[11] = { 0.06649, 0.1284697563, 0.111918249, 0.0873132676, 0.0610011113, 0.0381655709, 0.0213835661, 0.0107290241, 0.0048206869, 0.0019396469, 0.0006988718 };
#line 69
color *= weight[0];
#line 71
[loop]
for(int i = 1; i < 11; ++i)
{
color += tex2D(GaussianBlurSampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(GaussianBlurSampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 79
if(GaussianBlurRadius == 3)
{
float offset[15] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4401038149, 21.43402885, 23.4279736431, 25.4219399344, 27.4159294386 };
float weight[15] = { 0.0443266667, 0.0872994708, 0.0820892038, 0.0734818355, 0.0626171681, 0.0507956191, 0.0392263968, 0.0288369812, 0.0201808877, 0.0134446557, 0.0085266392, 0.0051478359, 0.0029586248, 0.0016187257, 0.0008430913 };
#line 84
color *= weight[0];
#line 86
[loop]
for(int i = 1; i < 15; ++i)
{
color += tex2D(GaussianBlurSampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(GaussianBlurSampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 94
if(GaussianBlurRadius == 4)
{
float offset[18] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4661974725, 21.4627427973, 23.4592916956, 25.455844494, 27.4524015179, 29.4489630909, 31.445529535, 33.4421011704 };
float weight[18] = { 0.033245, 0.0659162217, 0.0636705814, 0.0598194658, 0.0546642566, 0.0485871646, 0.0420045997, 0.0353207015, 0.0288880982, 0.0229808311, 0.0177815511, 0.013382297, 0.0097960001, 0.0069746748, 0.0048301008, 0.0032534598, 0.0021315311, 0.0013582974 };
#line 99
color *= weight[0];
#line 101
[loop]
for(int i = 1; i < 18; ++i)
{
color += tex2D(GaussianBlurSampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(GaussianBlurSampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).y) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 109
float3 orig = tex2D(ReShade::BackBuffer, texcoord).rgb;
orig = lerp(orig, color, GaussianBlurStrength);
#line 112
return saturate(orig);
}
#line 115
float3 GaussianBlur1(in float4 pos : SV_Position, in float2 texcoord : TEXCOORD) : COLOR
{
#line 118
float3 color = tex2D(ReShade::BackBuffer, texcoord).rgb;
#line 120
if(GaussianBlurRadius == 0)
{
float offset[4] = { 0.0, 1.1824255238, 3.0293122308, 5.0040701377 };
float weight[4] = { 0.39894, 0.2959599993, 0.0045656525, 0.00000149278686458842 };
#line 125
color *= weight[0];
#line 127
[loop]
for(int i = 1; i < 4; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 135
if(GaussianBlurRadius == 1)
{
float offset[6] = { 0.0, 1.4584295168, 3.40398480678, 5.3518057801, 7.302940716, 9.2581597095 };
float weight[6] = { 0.13298, 0.23227575, 0.1353261595, 0.0511557427, 0.01253922, 0.0019913644 };
#line 140
color *= weight[0];
#line 142
[loop]
for(int i = 1; i < 6; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 150
if(GaussianBlurRadius == 2)
{
float offset[11] = { 0.0, 1.4895848401, 3.4757135714, 5.4618796741, 7.4481042327, 9.4344079746, 11.420811147, 13.4073334, 15.3939936778, 17.3808101174, 19.3677999584 };
float weight[11] = { 0.06649, 0.1284697563, 0.111918249, 0.0873132676, 0.0610011113, 0.0381655709, 0.0213835661, 0.0107290241, 0.0048206869, 0.0019396469, 0.0006988718 };
#line 155
color *= weight[0];
#line 157
[loop]
for(int i = 1; i < 11; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 165
if(GaussianBlurRadius == 3)
{
float offset[15] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4401038149, 21.43402885, 23.4279736431, 25.4219399344, 27.4159294386 };
float weight[15] = { 0.0443266667, 0.0872994708, 0.0820892038, 0.0734818355, 0.0626171681, 0.0507956191, 0.0392263968, 0.0288369812, 0.0201808877, 0.0134446557, 0.0085266392, 0.0051478359, 0.0029586248, 0.0016187257, 0.0008430913 };
#line 170
color *= weight[0];
#line 172
[loop]
for(int i = 1; i < 15; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
}
}
#line 180
if(GaussianBlurRadius == 4)
{
float offset[18] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4661974725, 21.4627427973, 23.4592916956, 25.455844494, 27.4524015179, 29.4489630909, 31.445529535, 33.4421011704 };
float weight[18] = { 0.033245, 0.0659162217, 0.0636705814, 0.0598194658, 0.0546642566, 0.0485871646, 0.0420045997, 0.0353207015, 0.0288880982, 0.0229808311, 0.0177815511, 0.013382297, 0.0097960001, 0.0069746748, 0.0048301008, 0.0032534598, 0.0021315311, 0.0013582974 };
#line 185
color *= weight[0];
#line 187
[loop]
for(int i = 1; i < 18; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 2560), (1.0 / 1440)).x, 0.0) * GaussianBlurOffset).rgb * weight[i];
}
}
return saturate(color);
}
#line 197
technique GaussianBlur
{
pass Blur1
{
VertexShader = PostProcessVS;
PixelShader = GaussianBlur1;
RenderTarget = GaussianBlurTex;
}
pass BlurFinal
{
VertexShader = PostProcessVS;
PixelShader = GaussianBlurFinal;
}
}

