#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\GrainSpread.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\GrainSpread.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 2 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\GrainSpread.fx"
#line 4
uniform float Opacity
<
     ui_type = "slider"; 
#line 8
ui_label = "Opacity";
ui_tooltip = "Default: 0.5";
ui_min = 0.0;
ui_max = 1.0;
> = 0.5;
#line 14
uniform float Spread
<
     ui_type = "slider"; 
#line 18
ui_label = "Spread";
ui_tooltip = "Default: 0.5";
ui_min = 0.0;
ui_max = 500.0;
> = 1.0;
#line 24
uniform float Speed
<
     ui_type = "slider"; 
#line 28
ui_label = "Speed";
ui_tooltip = "Default: 1.0";
ui_min = 0.0;
ui_max = 1.0;
> = 1.0;
#line 34
uniform float GlobalGrain
<
     ui_type = "slider"; 
#line 38
ui_label = "Global Grain";
ui_tooltip = "Default: 0.5";
ui_min = 0.0;
ui_max = 1.0;
> = 0.5;
#line 44
uniform int BlendMode
<
       ui_type = "combo"; 
#line 48
ui_label = "Blend Mode";
ui_items = "Mix\0Addition\0Screen\0Lighten-Only\0";
> = 0;
#line 52
uniform float Timer <source = "timer";>;
#line 54
float rand(float2 uv, float t) {
return frac(sin(dot(uv, float2(1225.6548, 321.8942))) * 4251.4865 + t);
}
#line 58
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float t = Timer * 0.001 * Speed;
float2 scale = Spread;
float2 offset = float2(rand(uv, t), rand(uv.yx, t));
offset = offset * scale - scale * 0.5;
#line 65
float3 grain =  tex2D(ReShade::BackBuffer, uv, offset).rgb;
grain *= log10(Spread * 0.5 - distance(uv, uv + offset * ReShade::PixelSize));
grain *= lerp(1.0, rand(uv + uv.yx, t), GlobalGrain);
#line 70
float3 color = tex2D(ReShade::BackBuffer, uv).rgb;
#line 72
switch (BlendMode)
{
case 0: 
color = lerp(color, max(color, grain), Opacity);
break;
case 1: 
color += grain * Opacity;
break;
case 2: 
color = 1.0 - (1.0 - color) * (1.0 - grain * Opacity);
break;
case 3: 
color = max(color, grain * Opacity);
break;
}
#line 88
return float4(color, 1.0);
}
#line 91
technique GrainSpread
{
pass MainPS
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
}
}
