#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 4 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ColorLab.fxh"
#line 13
namespace FXShaders { namespace ColorLab
{
#line 16
static const float Gamma = 2.2;
static const float GammaInv = 1.0 / Gamma;
#line 19
static const float L_k = 903.3;
static const float L_e = 0.008856;
#line 22
static const float WhitePoint = 1.0;
#line 24
static const float3x3 RGBToXYZ_sRGB = float3x3(
0.4124564, 0.3575761, 0.1804375,
0.2126729, 0.7151522, 0.0721750,
0.0193339, 0.1191920, 0.9503041);
#line 29
static const float3x3 XYZToRGB_sRGB = float3x3(
3.2404542, -1.5371385, -0.4985314,
-0.9692660,  1.8760108,  0.0415560,
0.0556434, -0.2040259,  1.0572252);
#line 34
float3 gamma_to_linear(float3 c, float g)
{
return pow(abs(c), g);
}
#line 39
float3 gamma_to_linear(float3 c)
{
return gamma_to_linear(c, Gamma);
}
#line 44
float3 linear_to_gamma(float3 c, float g)
{
return pow(abs(c), rcp(g));
}
#line 49
float3 linear_to_gamma(float3 c)
{
return pow(abs(c), GammaInv);
}
#line 54
float3 srgb_to_linear(float3 c)
{
return (c < 0.04045)
? c / 12.92
: pow(abs((c + 0.055) / 1.055), 2.4);
}
#line 61
float3 linear_to_srgb(float3 c)
{
return (c < 0.0031308)
? 12.92 * c
: 1.055 * pow(abs(c), rcp(2.4)) - 0.055;
}
#line 68
float3 l_to_linear(float3 c)
{
return (c < 0.08)
? (100 * c) / L_k
: pow(abs((c + 0.16) / 1.16), 3.0);
}
#line 75
float3 linear_to_l(float3 c)
{
return (c < L_e)
? (c * L_k) / 100.0
: 1.16 * pow(abs(c), rcp(3.0)) - 0.16;
}
#line 82
float3 rgb_to_xyz(float3 c)
{
return mul(RGBToXYZ_sRGB, c);
}
#line 87
float3 xyz_to_rgb(float3 c)
{
return mul(XYZToRGB_sRGB, c);
}
#line 92
float3 xyz_to_lab(float3 c, float w)
{
c /= w;
#line 96
c = (c > L_e)
? pow(abs(c), rcp(3.0))
: (L_k * c + 16.0) / 116.0;
#line 100
float3 lab;
lab.x = 116.0 * c.y - 16.0;
lab.y = 500.0 * (c.x - c.y);
lab.z = 200.0 * (c.y - c.z);
#line 105
return lab;
}
#line 108
float3 xyz_to_lab(float3 c)
{
return xyz_to_lab(c, WhitePoint);
}
#line 113
float3 lab_to_xyz(float3 lab, float w)
{
float3 c;
c.y = (lab.x + 16.0) / 116.0;
c.x = lab.y / 500.0 + c.y;
c.z = c.y - lab.z / 200.0;
#line 120
float f3 = c.x * c.x * c.x;
c.x = (f3 > L_e)
? f3
: (116.0 * c.x - 16.0) / L_k;
#line 125
c.y = (lab.x > L_k * L_e)
? pow(abs((lab.x + 16.0) / 116.0), 3.0)
: lab.x / L_k;
#line 129
f3 = c.z * c.z * c.z;
c.z = (f3 > L_e)
? f3
: (116.0 * c.z - 16.0) / L_k;
#line 134
c *= w;
return c;
}
#line 138
float3 lab_to_xyz(float3 lab)
{
return lab_to_xyz(lab, WhitePoint);
}
#line 143
float3 rgb_to_lab(float3 c, float w)
{
return xyz_to_lab(rgb_to_xyz(c), w);
}
#line 148
float3 rgb_to_lab(float3 c)
{
return rgb_to_lab(c, WhitePoint);
}
#line 153
float3 lab_to_rgb(float3 c, float w)
{
return xyz_to_rgb(lab_to_xyz(c, w));
}
#line 158
float3 lab_to_rgb(float3 c)
{
return lab_to_rgb(c, WhitePoint);
}
#line 163
}}
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Blending.fxh"
#line 3
namespace FXShaders
{
#line 14
float3 BlendScreen(float3 a, float3 b, float w)
{
return 1.0 - (1.0 - a) * (1.0 - b * w);
}
#line 27
float3 BlendOverlay(float3 a, float3 b, float w)
{
float3 color = (a < 0.5)
? 2.0 * a * b
: 1.0 - 2.0 * (1.0 - a) * (1.0 - b);
#line 33
return lerp(a, color, w);
}
#line 44
float3 BlendSoftLight(float3 a, float3 b, float w)
{
float3 color = (1.0 - 2.0 * b) * (a * a) + 2.0 * b * a;
#line 48
return lerp(a, color, w);
}
#line 59
float3 BlendHardLight(float3 a, float3 b, float w)
{
float3 color = (a > 0.5)
? 2.0 * a * b
: 1.0 - 2.0 * (1.0 - a) * (1.0 - b);
#line 65
return lerp(a, color, w);
}
#line 68
}
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3
namespace FXShaders
{
#line 68
static const float Pi = 3.14159;
#line 73
static const float DegreesToRadians = Pi / 180.0;
#line 78
static const float RadiansToDegrees = 180.0 / Pi;
#line 87
float2 GetOffsetByAngleDistance(float2 pos, float angle, float distance)
{
float2 cosSin;
sincos(angle, cosSin.y, cosSin.x);
#line 92
return mad(distance, cosSin, pos);
}
#line 102
float2 GetDirectionFromAngleMagnitude(float angle, float magnitude)
{
return GetOffsetByAngleDistance(0.0, angle, magnitude);
}
#line 114
float2 ClampMagnitude(float2 v, float2 minMax) {
if (v.x == 0.0 && v.y == 0.0)
{
return 0.0;
}
else
{
float mag = length(v);
return (mag < minMax.x) ? 0.0 : (v / mag) * min(mag, minMax.y);
}
}
#line 133
float2 RotatePoint(float2 uv, float angle, float2 pivot)
{
float2 sc;
sincos(DegreesToRadians * angle, sc.x, sc.y);
#line 138
uv -= pivot;
uv = uv.x * sc.yx + float2(-uv.y, uv.y) * sc;
uv += pivot;
#line 142
return uv;
}
#line 145
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 11
namespace FXShaders
{
#line 18
static const float FloatEpsilon = 0.001;
#line 125
float2 GetResolution()
{
return float2(1920, 1080);
}
#line 133
float2 GetPixelSize()
{
return float2((1.0 / 1920), (1.0 / 1080));
}
#line 141
float GetAspectRatio()
{
return 1920 * (1.0 / 1080);
}
#line 149
float4 GetScreenParams()
{
return float4(GetResolution(), GetPixelSize());
}
#line 165
float2 ScaleCoord(float2 uv, float2 scale, float2 pivot)
{
return (uv - pivot) * scale + pivot;
}
#line 178
float2 ScaleCoord(float2 uv, float2 scale)
{
return ScaleCoord(uv, scale, 0.5);
}
#line 188
float GetLumaGamma(float3 color)
{
return dot(color, float3(0.299, 0.587, 0.114));
}
#line 199
float GetLumaLinear(float3 color)
{
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 212
float3 checkered_pattern(float2 uv, float size, float color_a, float color_b)
{
static const float cSize = 32.0;
static const float3 cColorA = pow(0.15, 2.2);
static const float3 cColorB = pow(0.5, 2.2);
#line 218
uv *= GetResolution();
uv %= cSize;
#line 221
float half_size = cSize * 0.5;
float checkered = step(uv.x, half_size) == step(uv.y, half_size);
return (cColorA * checkered) + (cColorB * (1.0 - checkered));
}
#line 232
float3 checkered_pattern(float2 uv)
{
static const float Size = 32.0;
static const float ColorA = pow(0.15, 2.2);
static const float ColorB = pow(0.5, 2.2);
#line 238
return checkered_pattern(uv, Size, ColorA, ColorB);
}
#line 251
float3 ApplySaturation(float3 color, float amount)
{
float gray = GetLumaLinear(color);
return gray + (color - gray) * amount;
}
#line 262
float GetRandom(float2 uv)
{
#line 267
static const float A = 23.2345;
static const float B = 84.1234;
static const float C = 56758.9482;
#line 271
return frac(sin(dot(uv, float2(A, B))) * C);
}
#line 281
void ScreenVS(
uint id : SV_VERTEXID,
out float4 pos : SV_POSITION,
out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
#line 289
pos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 300
float2 CorrectAspectRatio(float2 uv, float a, float b)
{
if (a > b)
{
#line 306
uv = ScaleCoord(uv, float2(1.0 / a, 1.0));
}
else
{
#line 312
uv = ScaleCoord(uv, float2(1.0, 1.0 / b));
}
#line 315
return uv;
}
#line 318
} 
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Convolution.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Convolution.fxh"
#line 5
namespace FXShaders
{
#line 18
float NormalDistribution(float x, float u, float o)
{
o *= o;
#line 22
float a = 1.0 / sqrt(2.0 * Pi * o);
float b = x - u;
b *= b;
b /= 2.0 * o;
#line 27
return a * exp(-(b));
}
#line 38
float Gaussian1D(float x, float o)
{
o *= o;
float a = 1.0 / sqrt(2.0 * Pi * o);
float b = (x * x) / (2.0 * o);
return a * exp(-b);
}
#line 55
float Gaussian1DFast(float x, float o)
{
#line 59
return exp(-(x * x) / (2.0 * o * o));
}
#line 70
float Gaussian2D(float2 i, float o)
{
o *= o;
float a = 1.0 / (2.0 * Pi * o);
float b = (i.x * i.x + i.y * i.y) / (2.0 * o);
return a * exp(-b);
}
#line 91
float4 GaussianBlur1D(
sampler sp,
float2 uv,
float2 dir,
float sigma,
int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
#line 100
float4 color = 0.0;
float accum = 0.0;
#line 103
uv -= halfSamples * dir;
#line 105
[unroll]
for (int i = 0; i < samples; ++i)
{
float weight = Gaussian1DFast(i - halfSamples, sigma);
#line 110
color += tex2D(sp, uv) * weight;
accum += weight;
#line 113
uv += dir;
}
#line 116
return color / accum;
}
#line 132
float4 GaussianBlur2D(
sampler sp,
float2 uv,
float2 scale,
float sigma,
int2 samples)
{
static const float2 halfSamples = samples * 0.5;
#line 141
float4 color = 0.0;
float accum = 0.0;
#line 144
uv -= halfSamples * scale;
#line 146
[unroll]
for (int x = 0; x < samples.x; ++x)
{
float initX = uv.x;
#line 151
[unroll]
for (int y = 0; y < samples.y; ++y)
{
float2 pos = float2(x, y);
float weight = Gaussian2D(abs(pos - halfSamples), sigma);
#line 157
color += tex2D(sp, uv) * weight;
accum += weight;
#line 160
uv.x += scale.x;
}
#line 163
uv.x = initX;
uv.y += scale.y;
}
#line 167
return color / accum;
}
#line 170
float4 LinearBlur1D(sampler sp, float2 uv, float2 dir, int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
uv -= halfSamples * dir;
#line 175
float4 color = 0.0;
#line 177
[unroll]
for (int i = 0; i < samples; ++i)
{
color += tex2D(sp, uv);
uv += dir;
}
#line 184
return color / samples;
}
#line 187
float4 MaxBlur1D(sampler sp, float2 uv, float2 dir, int samples)
{
static const float halfSamples = (samples - 1) * 0.5;
uv -= halfSamples * dir;
#line 192
float4 color = 0.0;
#line 194
[unroll]
for (int i = 0; i < samples; ++i)
{
color = max(color, tex2D(sp, uv));
uv += dir;
}
#line 201
return color;
}
#line 204
float4 SharpBlur1D(sampler sp, float2 uv, float2 dir, int samples, float sharpness)
{
static const float halfSamples = (samples - 1) * 0.5;
static const float weight = 1.0 / samples;
#line 209
uv -= halfSamples * dir;
#line 211
float4 color = 0.0;
#line 213
[unroll]
for (int i = 0; i < samples; ++i)
{
float4 pixel = tex2D(sp, uv);
color = lerp(color + pixel * weight, max(color, pixel), sharpness);
uv += dir;
}
#line 221
return color;
}
#line 224
} 
#line 8 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Dithering.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Dithering.fxh"
#line 5
namespace FXShaders { namespace Dithering
{
#line 8
namespace Ordered16
{
static const int Width = 4;
#line 12
static const int Pattern[Width * Width] =
{
0, 8, 2, 10,
12, 4, 14, 6,
3, 11, 1, 9,
15, 7, 13, 5
};
#line 20
float3 Apply(float3 color, float2 uv, float amount)
{
int2 pos = uv * GetResolution();
pos %= Width;
#line 25
float value = Pattern[pos.x * Width + pos.y];
value /= Width * Width;
#line 28
color *= 1.0 + (value * 2.0 - 1.0) * amount;
#line 30
return color;
}
}
#line 34
}} 
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Tonemap.fxh"
#line 11
namespace FXShaders { namespace Tonemap
{
#line 14
namespace Type
{
static const int Reinhard = 0;
static const int Uncharted2Filmic = 1;
static const int BakingLabACES = 2;
static const int NarkowiczACES = 3;
static const int Unreal3 = 4;
static const int Lottes = 5;
}
#line 24
namespace Reinhard
{
#line 31
float3 Apply(float3 color)
{
return color / (1.0 + color);
}
#line 41
float3 Inverse(float3 color)
{
return -(color / min(color - 1.0, -0.1));
}
#line 55
float3 InverseOld(float3 color, float w)
{
return color / max(1.0 - color, w);
}
#line 69
float3 InverseOldLum(float3 color, float w)
{
float lum = max(color.r, max(color.g, color.b));
return color * (lum / max(1.0 - lum, w));
}
}
#line 76
namespace Uncharted2Filmic
{
#line 79
static const float A = 0.15;
#line 82
static const float B = 0.50;
#line 85
static const float C = 0.10;
#line 88
static const float D = 0.20;
#line 91
static const float E = 0.02;
#line 94
static const float F = 0.30;
#line 96
float3 Apply(float3 color)
{
color =
(
(color * (A * color + C * B) + D * E) /
(color * (A * color + B) + D * F)
) - E / F;
#line 104
return color;
}
#line 107
float3 Inverse(float3 color)
{
return abs(
((B * C * F - B * E - B * F * color) -
sqrt(
pow(abs(-B * C * F + B * E + B * F * color), 2.0) -
4.0 * D * (F * F) * color * (A * E + A * F * color - A * F))) /
(2.0 * A * (E + F * color - F)));
}
}
#line 118
namespace BakingLabACES
{
#line 121
static const float3x3 ACESInputMat = float3x3
(
0.59719, 0.35458, 0.04823,
0.07600, 0.90834, 0.01566,
0.02840, 0.13383, 0.83777
);
#line 129
static const float3x3 ACESOutputMat = float3x3
(
1.60475, -0.53108, -0.07367,
-0.10208,  1.10813, -0.00605,
-0.00327, -0.07276,  1.07602
);
#line 136
float3 RRTAndODTFit(float3 v)
{
float3 a = v * (v + 0.0245786f) - 0.000090537f;
float3 b = v * (0.983729f * v + 0.4329510f) + 0.238081f;
return a / b;
}
#line 143
float3 ACESFitted(float3 color)
{
color = mul(ACESInputMat, color);
#line 148
color = RRTAndODTFit(color);
#line 150
color = mul(ACESOutputMat, color);
#line 153
color = saturate(color);
#line 155
return color;
}
#line 158
static const float A = 0.0245786;
static const float B = 0.000090537;
static const float C = 0.983729;
static const float D = 0.4329510;
static const float E = 0.238081;
#line 164
float3 Apply(float3 color)
{
return saturate(
(color * (color + A) - B) /
(color * (C * color + D) + E));
}
#line 171
float3 Inverse(float3 color)
{
return abs(
((A - D * color) -
sqrt(
pow(abs(D * color - A), 2.0) -
4.0 * (C * color - 1.0) * (B + E * color))) /
(2.0 * (C * color - 1.0)));
}
}
#line 182
namespace Lottes
{
float3 Apply(float3 color)
{
return color * rcp(max(color.r, max(color.g, color.b)) + 1.0);
}
#line 189
float3 Inverse(float3 color)
{
return color * rcp(max(1.0 - max(color.r, max(color.g, color.b)), 0.1));
}
}
#line 195
namespace NarkowiczACES
{
static const float A = 2.51;
static const float B = 0.03;
static const float C = 2.43;
static const float D = 0.59;
static const float E = 0.14;
#line 203
float3 Apply(float3 color)
{
return saturate(
(color * (A * color + B)) / (color * (C * color + D) + E));
}
#line 209
float3 Inverse(float3 color)
{
return
((D * color - B) +
sqrt(
4.0 * A * E * color + B * B -
2.0 * B * D * color -
4.0 * C * E * color * color +
D * D * color * color)) /
(2.0 * (A - C * color));
}
}
#line 222
namespace Unreal3
{
float3 Apply(float3 color)
{
return color / (color + 0.155) * 1.019;
}
#line 229
float3 Inverse(float3 color)
{
return (color * -0.155) / (max(color, 0.01) - 1.019);
}
}
#line 235
float3 Apply(int type, float3 color)
{
switch (type)
{
case Type::Reinhard:
return Reinhard::Apply(color);
case Type::Uncharted2Filmic:
return Uncharted2Filmic::Apply(color);
case Type::BakingLabACES:
return BakingLabACES::Apply(color);
case Type::NarkowiczACES:
return NarkowiczACES::Apply(color);
case Type::Unreal3:
return Unreal3::Apply(color);
case Type::Lottes:
return Lottes::Apply(color);
}
#line 253
return color;
}
#line 256
float3 Inverse(int type, float3 color)
{
switch (type)
{
case Type::Reinhard:
return Reinhard::Inverse(color);
case Type::Uncharted2Filmic:
return Uncharted2Filmic::Inverse(color);
case Type::BakingLabACES:
return BakingLabACES::Inverse(color);
case Type::NarkowiczACES:
return NarkowiczACES::Inverse(color);
case Type::Unreal3:
return Unreal3::Inverse(color);
case Type::Lottes:
return Lottes::Inverse(color);
}
#line 274
return color;
}
#line 277
}} 
#line 10 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\NeoBloom.fx"
#line 85
namespace FXShaders
{
#line 90
struct BlendPassParams
{
float4 p : SV_POSITION;
float2 uv : TEXCOORD0;
#line 98
};
#line 105
static const int BloomCount = 5;
static const float4 BloomLevels[] =
{
float4(0.0, 0.5, 0.5, 1),
float4(0.5, 0.0, 0.25, 2),
float4(0.75, 0.875, 0.125, 3),
float4(0.875, 0.0, 0.0625, 5),
float4(0.0, 0.0, 0.03, 7)
#line 114
};
static const int MaxBloomLevel = BloomCount - 1;
#line 117
static const int BlurSamples =  27;
#line 119
static const float2 PixelScale = 1.0;
#line 121
static const float2 DirtResolution = float2(
 1280,
 720);
static const float2 DirtPixelSize = 1.0 / DirtResolution;
static const float DirtAspectRatio = DirtResolution.x * DirtPixelSize.y;
static const float DirtAspectRatioInv = 1.0 / DirtAspectRatio;
#line 128
static const int DebugOption_None = 0;
static const int DebugOption_OnlyBloom = 1;
static const int DebugOptions_TextureAtlas = 2;
static const int DebugOption_Adaptation = 3;
#line 136
static const int DebugOption_DepthRange = 3;
#line 139
static const int AdaptMode_FinalImage = 0;
static const int AdaptMode_OnlyBloom = 1;
#line 142
static const int BloomBlendMode_Mix = 0;
static const int BloomBlendMode_Addition = 1;
static const int BloomBlendMode_Screen = 2;
#line 360
uniform int _Help < ui_text =
"NeoBloom has many options and may be difficult to setup or may look "
"bad at first, but it's designed to be very flexible to adapt to many "
"different cases.\n"
"Make sure to take a look at the preprocessor definitions at the "
"bottom!\n"
"For more specific descriptions, move the mouse cursor over the name "
"of the option you need help with.\n"
"\n"
"Here's a general description of the features:\n"
"\n"
"  Bloom:\n"
"    Basic options for controlling the look of bloom itself.\n"
"\n"
"  Adaptation:\n"
"    Used to dynamically increase or reduce the image brightness "
"depending on the scene, giving an HDR look.\n"
"    Looking at a bright object, like a lamp, would cause the image to "
"darken; lookinng at a dark spot, like a cave, would cause the "
"image to brighten.\n"
"\n"
"  Blending:\n"
"    Used to control how the different bloom textures are blended, "
"each representing a different level-of-detail.\n"
"    Can be used to simulate an old mid-2000s bloom, ambient light "
"etc.\n"
"\n"
"  Ghosting:\n"
"    Smoothens the bloom between frames, causing a \"motion blur\" or "
"\"trails\" effect.\n"
"\n"
"  Depth:\n"
"    Used to increase or decrease the brightness of parts of the image "
"depending on depth.\n"
"    Can be used for effects like brightening the sky.\n"
"    An optional anti-flicker feature is available to help with games "
"with depth flickering problems, which can cause bloom to flicker as "
"well with the depth feature enabled.\n"
"\n"
"  HDR:\n"
"    Options for controlling the high dynamic range simulation.\n"
"    Useful for simulating a more foggy bloom, like an old soap opera, "
"a high-contrast sunny look etc.\n"
"\n"
"  Blur:\n"
"    Options for controlling the blurring effect used to generate the "
"bloom textures.\n"
"    Mostly can be left untouched.\n"
"\n"
"  Debug:\n"
"    Enables testing options, like viewing the bloom texture alone, "
"before mixing with the image.\n"
#line 204
; ui_category = "Help"; ui_category_closed = true; ui_label = " "; ui_type = "radio"; >;
#line 206
uniform float Intensity
<
     ui_type = "slider"; 
#line 210
ui_label = "Intensity";
ui_tooltip =
"Determines how much bloom is added to the image. For HDR games you'd "
"generally want to keep this low-ish, otherwise everything might look "
"too bright.\n"
"\nDefault: 1.0";
ui_category = "Bloom";
ui_min = 0.0;
ui_max = 1.0;
> = 1.0;
#line 221
uniform float Saturation
<
     ui_type = "slider"; 
#line 225
ui_label = "Saturation";
ui_tooltip =
"Saturation of the bloom texture.\n"
"\nDefault: 1.0";
ui_category = "Bloom";
ui_min = 0.0;
ui_max = 3.0;
> = 1.0;
#line 234
uniform float3 ColorFilter
<
     ui_type = "color"; 
#line 238
ui_label = "Color Filter";
ui_tooltip =
"Color multiplied to the bloom, filtering it.\n"
"Set to full white (255, 255, 255) to disable it.\n"
"\nDefault: 255 255 255";
ui_category = "Bloom";
> = float3(1.0, 1.0, 1.0);
#line 246
uniform int BloomBlendMode
<
       ui_type = "combo"; 
#line 250
ui_label = "Blend Mode";
ui_tooltip =
"Determines the formula used to blend bloom with the scene color.\n"
"Certain blend modes may not play well with other options.\n"
"As a fallback, addition always works.\n"
"\nDefault: Mix";
ui_category = "Bloom";
ui_items = "Mix\0Addition\0Screen\0";
> = 1;
#line 420
uniform float Mean
<
     ui_type = "slider"; 
#line 424
ui_label = "Mean";
ui_tooltip =
"Acts as a bias between all the bloom textures/sizes. What this means "
"is that lower values will yield more detail bloom, while the opposite "
"will yield big highlights.\n"
"The more variance is specified, the less effective this setting is, "
"so if you want to have very fine detail bloom reduce both "
"parameters.\n"
"\nDefault: 0.0";
ui_category = "Blending";
ui_min = 0.0;
ui_max = BloomCount;
#line 437
> = 0.0;
#line 439
uniform float Variance
<
     ui_type = "slider"; 
#line 443
ui_label = "Variance";
ui_tooltip =
"Determines the 'variety'/'contrast' in bloom textures/sizes. This "
"means a low variance will yield more of the bloom size specified by "
"the mean; that is to say that having a low variance and mean will "
"yield more fine-detail bloom.\n"
"A high variance will diminish the effect of the mean, since it'll "
"cause all the bloom textures to blend more equally.\n"
"A low variance and high mean would yield an effect similar to "
"an 'ambient light', with big blooms of light, but few details.\n"
"\nDefault: 1.0";
ui_category = "Blending";
ui_min = 1.0;
ui_max = BloomCount;
#line 458
> = BloomCount;
#line 557
uniform float MaxBrightness
<
     ui_type = "drag"; 
#line 561
ui_label  = "Max Brightness";
ui_tooltip =
"tl;dr: HDR contrast.\n"
"\nDetermines the maximum brightness a pixel can achieve from being "
"'reverse-tonemapped', that is to say, when the effect attempts to "
"extract HDR information from the image.\n"
"In practice, the difference between a value of 100 and one of 1000 "
"would be in how bright/bloomy/big a white pixel could become, like "
"the sun or the headlights of a car.\n"
"Lower values can also work for making a more 'balanced' bloom, where "
"there are less harsh highlights and the entire scene is equally "
"foggy, like an old TV show or with dirty lenses.\n"
"\nDefault: 100.0";
ui_category = "HDR";
ui_min = 1.0;
ui_max = 1000.0;
ui_step = 1.0;
> = 100.0;
#line 580
uniform bool NormalizeBrightness
<
ui_label = "Normalize Brightness";
ui_tooltip =
"Whether to normalize the bloom brightness when blending with the "
"image.\n"
"Without it, the bloom may have very harsh bright spots.\n"
"\nDefault: On";
ui_category = "HDR";
> = true;
#line 591
uniform bool MagicMode
<
ui_label = "Magic Mode";
ui_tooltip =
"When enabled, simulates the look of MagicBloom.\n"
"This is an experimental option and may be inconsistent with other "
"parameters.\n"
"\nDefault: Off";
ui_category = "HDR";
> = false;
#line 604
uniform float Sigma
<
     ui_type = "drag"; 
#line 608
ui_label = "Sigma";
ui_tooltip =
"Amount of blurriness. Values too high will break the blur.\n"
"Recommended values are between 2 and 4.\n"
"\nDefault: 2.0";
ui_category = "Blur";
ui_min = 1.0;
ui_max = 10.0;
ui_step = 0.01;
> = 4.0;
#line 619
uniform float Padding
<
     ui_type = "drag"; 
#line 623
ui_label = "Padding";
ui_tooltip =
"Specifies additional padding around the bloom textures in the "
"internal texture atlas, which is used during the blurring process.\n"
"The reason for this is to reduce the loss of bloom brightness around "
"the screen edges, due to the way the blurring works.\n"
"\n"
"If desired, it can be set to zero to purposefully reduce the "
"amount of bloom around the edges.\n"
"It may be necessary to increase this parameter when increasing the "
"blur sigma, samples and/or bloom down scale.\n"
"\n"
"Due to the way it works, it's recommended to keep the value as low "
"as necessary, since it'll cause the blurring process to work in a "
"\"lower\" resolution.\n"
"\n"
"If you're still confused about this parameter, try viewing the "
"texture atlas with debug mode and watch what happens when it is "
"increased.\n"
"\nDefault: 0.1";
ui_category = "Blur";
ui_min = 0.0;
ui_max = 10.0;
ui_step = 0.001;
> = 0.1;
#line 732
sampler BackBuffer
{
Texture = ReShade::BackBufferTex;
SRGBTexture = true;
};
#line 738
texture NeoBloom_DownSample <pooled="true";>
{
Width =  1024;
Height =  1024;
Format = RGBA16F;
MipLevels =  11;
};
sampler DownSample
{
Texture = NeoBloom_DownSample;
};
#line 750
texture NeoBloom_AtlasA <pooled="true";>
{
Width = 1920 /  2;
Height = 1080 /  2;
Format = RGBA16F;
};
sampler AtlasA
{
Texture = NeoBloom_AtlasA;
AddressU = BORDER;
AddressV = BORDER;
};
#line 763
texture NeoBloom_AtlasB <pooled="true";>
{
Width = 1920 /  2;
Height = 1080 /  2;
Format = RGBA16F;
};
sampler AtlasB
{
Texture = NeoBloom_AtlasB;
AddressU = BORDER;
AddressV = BORDER;
};
#line 860
float3 blend_bloom(float3 color, float3 bloom)
{
float w;
if (NormalizeBrightness)
w = Intensity / MaxBrightness;
else
w = Intensity;
#line 868
switch (BloomBlendMode)
{
default:
return 0.0;
case BloomBlendMode_Mix:
return lerp(color, bloom, log2(w + 1.0));
case BloomBlendMode_Addition:
return color + bloom * w * 3.0;
case BloomBlendMode_Screen:
return BlendScreen(color, bloom, w);
}
}
#line 881
float3 inv_tonemap_bloom(float3 color)
{
if (MagicMode)
return pow(abs(color), MaxBrightness * 0.01);
#line 886
return Tonemap::Reinhard::InverseOldLum(color, 1.0 / MaxBrightness);
}
#line 889
float3 inv_tonemap(float3 color)
{
if (MagicMode)
return color;
#line 894
return Tonemap::Reinhard::InverseOld(color, 1.0 / MaxBrightness);
}
#line 897
float3 tonemap(float3 color)
{
if (MagicMode)
return color;
#line 902
return Tonemap::Reinhard::Apply(color);
}
#line 928
float4 DownSamplePS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(BackBuffer, uv);
color.rgb = saturate(ApplySaturation(color.rgb, Saturation));
color.rgb *= ColorFilter;
color.rgb = inv_tonemap_bloom(color.rgb);
#line 958
return color;
}
#line 961
float4 SplitPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = 0.0;
#line 965
[unroll]
for (int i = 0; i < BloomCount; ++i)
{
float4 rect = BloomLevels[i];
float2 rect_uv = ScaleCoord(uv - rect.xy, 1.0 / rect.z, 0.0);
float inbounds =
step(0.0, rect_uv.x) * step(rect_uv.x, 1.0) *
step(0.0, rect_uv.y) * step(rect_uv.y, 1.0);
#line 974
rect_uv = ScaleCoord(rect_uv, 1.0 + Padding * (i + 1), 0.5);
#line 976
float4 pixel = tex2Dlod(DownSample, float4(rect_uv, 0, rect.w));
pixel.rgb *= inbounds;
pixel.a = inbounds;
#line 980
color += pixel;
}
#line 983
return color;
}
#line 986
float4 BlurXPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float2 dir =
PixelScale *
float2((1.0 / 1920), 0.0) *
 2;
#line 993
return GaussianBlur1D(AtlasA, uv, dir, Sigma, BlurSamples);
}
#line 996
float4 BlurYPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float2 dir =
PixelScale *
float2(0.0, (1.0 / 1080)) *
 2;
#line 1003
return GaussianBlur1D(AtlasB, uv, dir, Sigma, BlurSamples);
}
#line 1049
float4 JoinBloomsPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 bloom = 0.0;
float accum = 0.0;
#line 1054
[unroll]
for (int i = 0; i < BloomCount; ++i)
{
float4 rect = BloomLevels[i];
float2 rect_uv = ScaleCoord(uv, 1.0 / (1.0 + Padding * (i + 1)), 0.5);
rect_uv = ScaleCoord(rect_uv + rect.xy / rect.z, rect.z, 0.0);
#line 1061
float weight = NormalDistribution(i, Mean, Variance);
bloom += tex2D(AtlasA, rect_uv) * weight;
accum += weight;
}
bloom /= accum;
#line 1072
return bloom;
}
#line 1101
BlendPassParams BlendVS(uint id : SV_VERTEXID)
{
BlendPassParams p;
#line 1105
PostProcessVS(id, p.p, p.uv);
#line 1119
return p;
}
#line 1122
float4 BlendPS(BlendPassParams p) : SV_TARGET
{
float2 uv = p.uv;
#line 1126
float4 color = tex2D(BackBuffer, uv);
color.rgb = inv_tonemap(color.rgb);
#line 1132
float4 bloom = JoinBloomsPS(p.p, uv);
#line 1240
if (MagicMode)
bloom.rgb = Tonemap::Uncharted2Filmic::Apply(bloom.rgb * 10.0);
#line 1243
color.rgb = blend_bloom(color.rgb, bloom.rgb);
#line 1246
if (!MagicMode)
color.rgb = tonemap(color.rgb);
#line 1249
return color;
}
#line 1256
technique NeoBloom
{
#line 1267
pass DownSample
{
VertexShader = PostProcessVS;
PixelShader = DownSamplePS;
RenderTarget = NeoBloom_DownSample;
}
pass Split
{
VertexShader = PostProcessVS;
PixelShader = SplitPS;
RenderTarget = NeoBloom_AtlasA;
}
pass BlurX
{
VertexShader = PostProcessVS;
PixelShader = BlurXPS;
RenderTarget = NeoBloom_AtlasB;
}
pass BlurY
{
VertexShader = PostProcessVS;
PixelShader = BlurYPS;
RenderTarget = NeoBloom_AtlasA;
}
#line 1322
pass Blend
{
VertexShader = BlendVS;
PixelShader = BlendPS;
SRGBWriteEnable = true;
}
}
#line 1332
}

