#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\PiecewiseFilmicTonemap.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 10 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\PiecewiseFilmicTonemap.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 11 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\PiecewiseFilmicTonemap.fx"
#line 21
static const float EPSILON = 1e-3;
#line 29
uniform float2 Point0
<
     ui_type = "slider"; 
#line 33
ui_min = 0.0;
ui_max = 1.0;
> = float2(0.25, 0.25);
#line 37
uniform float2 Point1
<
     ui_type = "slider"; 
#line 41
ui_min = 0.0;
ui_max = 1.0;
> = float2(0.75, 0.75);
#line 45
uniform float Whitepoint
<
     ui_type = "slider"; 
#line 49
ui_min = 0.0;
ui_max = 1.0;
> = 1.0;
#line 53
uniform float2 Overshoot
<
     ui_type = "slider"; 
#line 57
ui_min = 0.0;
ui_max = 1.0;
> = float2(0.0, 0.0);
#line 119
uniform float Gamma
<
     ui_type = "slider"; 
#line 123
ui_label = "Gamma";
ui_min = 1.0;
ui_max = 5.0;
> = 1.0;
#line 132
sampler BackBuffer
{
Texture = ReShade::BackBufferTex;
MinFilter = POINT;
MagFilter = POINT;
MipFilter = POINT;
#line 139
};
#line 161
struct CurveParamsDirect
{
float2 p0, p1;
float w;
float2 overshoot;
float gamma;
};
#line 169
CurveParamsDirect CurveParamsDirect_new()
{
CurveParamsDirect self;
self.p0 = 0.25;
self.p1 = 0.75;
self.w = 1.0;
self.gamma = 1.0;
self.overshoot = 0.0;
return self;
}
#line 180
CurveParamsDirect CurveParamsDirect_new(
float2 p0, float2 p1, float w, float2 overshoot, float gamma)
{
CurveParamsDirect self;
self.p0 = p0;
self.p1 = p1;
self.w = w;
self.gamma = gamma;
self.overshoot = overshoot;
return self;
}
#line 194
struct CurveSegment
{
float2 offset, scale;
float ln_a, b;
};
#line 200
CurveSegment CurveSegment_new()
{
CurveSegment self;
self.offset = 0.0;
self.scale = 1.0;
self.ln_a = 0.0;
self.b = 1.0;
return self;
}
#line 210
CurveSegment CurveSegment_new(float2 offset, float2 scale, float ln_a, float b)
{
CurveSegment self;
self.offset = offset;
self.scale = scale;
self.ln_a = ln_a;
self.b = b;
return self;
}
#line 220
float CurveSegment_eval(CurveSegment self, float x)
{
float2 p0 = float2((x - self.offset.x) * self.scale.x, 0.0);
#line 224
if (p0.x > 0.0)
p0.y = exp(self.ln_a + self.b * log(p0.x));
#line 227
return p0.y * self.scale.y + self.offset.y;
}
#line 230
float CurveSegment_eval_inv(CurveSegment self, float y)
{
float2 p0 = float2(0.0, (y - self.offset.y) / self.scale.y);
#line 234
if (p0.y > 0.0)
p0.x = exp((log(p0.y) - self.ln_a) / self.b);
#line 237
return p0.x / self.scale.x + self.offset.x;
}
#line 242
struct FullCurve
{
float w, inv_w;
float2 p0, p1;
#line 248
float2 offset[3], scale[3];
float ln_a[3], b[3];
};
#line 252
CurveSegment FullCurve_get_segment(FullCurve self, int i)
{
return CurveSegment_new(
self.offset[i], self.scale[i], self.ln_a[i], self.b[i]);
}
#line 258
void FullCurve_set_segment(inout FullCurve self, int i, CurveSegment seg)
{
self.offset[i] = seg.offset;
self.scale[i] = seg.scale;
self.ln_a[i] = seg.ln_a;
self.b[i] = seg.b;
}
#line 266
FullCurve FullCurve_new()
{
FullCurve self;
self.w = 1.0;
self.inv_w = 1.0;
self.p0 = 0.25;
self.p1 = 0.75;
#line 274
[unroll]
for (int i = 0; i < 3; ++i)
FullCurve_set_segment(self, i, CurveSegment_new());
#line 278
return self;
}
#line 281
float FullCurve_eval(FullCurve self, float x)
{
float norm_x = x * self.inv_w;
int index = (norm_x < self.p0.x) ? 0 : ((norm_x < self.p1.x) ? 1 : 2);
CurveSegment segment = FullCurve_get_segment(self, index);
return CurveSegment_eval(segment, norm_x);
}
#line 289
float FullCurve_eval_inv(FullCurve self, float y)
{
int index = (y < self.p0.y) ? 0 : ((y < self.p1.y) ? 1 : 2);
CurveSegment segment = FullCurve_get_segment(self, index);
#line 294
float norm_x = CurveSegment_eval_inv(segment, y);
return norm_x * self.w;
}
#line 304
float2 solve_a_b(float2 p0, float m)
{
float b = (m * p0.x) / p0.y;
float ln_a = log(p0.y) - b * log(p0.x);
return float2(ln_a, b);
}
#line 312
float2 as_slope_intercept(float2 p0, float2 p1)
{
float2 d = p1 - p0;
float m = (d.x == 0.0) ? 1.0 : d.y / d.x;
float b = p0.y - p0.x * m;
return float2(m, b);
}
#line 320
float eval_derivative_linear_gamma(float m, float b, float g, float x)
{
return g * m * pow(abs(m * x + b), g - 1.0);
}
#line 325
FullCurve create_curve(CurveParamsDirect params)
{
FullCurve curve = FullCurve_new();
curve.w = params.w;
curve.inv_w = rcp(params.w);
#line 332
params.p0.x /= params.w;
params.p1.x /= params.w;
params.overshoot.x /= params.w;
#line 336
float toe_m = 0.0;
float shoulder_m = 0.0;
float endpoint_m = 0.0;
{
float2 m_b = as_slope_intercept(params.p0, params.p1);
float g = params.gamma;
#line 343
CurveSegment mid_segment = CurveSegment_new(
float2(-(m_b.y / m_b.x), 0.0), 1.0, g * log(m_b.x), g);
#line 346
FullCurve_set_segment(curve, 1, mid_segment);
#line 348
toe_m = eval_derivative_linear_gamma(m_b.x, m_b.y, g, params.p0.x);
shoulder_m = eval_derivative_linear_gamma(m_b.x, m_b.y, g, params.p1.x);
#line 351
params.p0.y = max(EPSILON, pow(abs(params.p0.y), params.gamma));
params.p1.y = max(EPSILON, pow(abs(params.p1.y), params.gamma));
#line 354
params.overshoot.y = pow(abs(1.0 + params.overshoot.y), params.gamma) - 1.0;
}
#line 357
curve.p0 = params.p0;
curve.p1 = params.p1;
#line 360
{
CurveSegment toe_segment = CurveSegment_new();
toe_segment.offset = 0.0;
toe_segment.scale = 1.0;
#line 365
float2 a_b = solve_a_b(params.p0, toe_m);
toe_segment.ln_a = a_b.x;
toe_segment.b = a_b.y;
FullCurve_set_segment(curve, 0, toe_segment);
}
#line 371
{
CurveSegment shoulder_segment = CurveSegment_new();
#line 374
float2 p0 = (1.0 + params.overshoot) - params.p1;
#line 376
float2 a_b = solve_a_b(p0, shoulder_m);
#line 378
shoulder_segment.offset = 1.0 + params.overshoot;
#line 380
shoulder_segment.scale = -1.0;
shoulder_segment.ln_a = a_b.x;
shoulder_segment.b = a_b.y;
#line 384
FullCurve_set_segment(curve, 2, shoulder_segment);
}
#line 387
{
float scale = CurveSegment_eval(FullCurve_get_segment(curve, 2), 1.0);
float inv_scale = rcp(scale);
#line 391
curve.offset[0].y *= inv_scale;
curve.scale[0].y *= inv_scale;
#line 394
curve.offset[1].y *= inv_scale;
curve.scale[1].y *= inv_scale;
#line 397
curve.offset[2].y *= inv_scale;
curve.scale[2].y *= inv_scale;
}
#line 401
return curve;
}
#line 438
float3 apply_filmic_curve(float3 color)
{
#line 442
CurveParamsDirect params = CurveParamsDirect_new(
Point0, Point1, Whitepoint, Overshoot, Gamma);
#line 451
FullCurve curve = create_curve(params);
#line 453
color = float3(
FullCurve_eval(curve, color.r),
FullCurve_eval(curve, color.g),
FullCurve_eval(curve, color.b));
#line 470
return color;
}
#line 473
float3 inv_reinhard(float3 color, float inv_max)
{
return (color / max(1.0 - color, inv_max));
}
#line 482
float4 MainPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float4 color = tex2D(BackBuffer, uv);
#line 488
color.rgb = apply_filmic_curve(color.rgb);
#line 490
return color;
}
#line 498
float4 DebugPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
#line 502
CurveParamsDirect params = CurveParamsDirect_new(
Point0, Point1, Whitepoint, Overshoot, Gamma);
#line 511
FullCurve curve = create_curve(params);
#line 513
float4 color = tex2D(ReShade::BackBuffer, uv);
float y = 1.0 - uv.y;
#line 516
y *= 2.0;
#line 518
float2 p0 = step(y, params.p0);
p0.x *= step(uv.x, 0.01);
p0.y *= step(0.01, uv.x) * step(uv.x, 0.02);
color.rgb = lerp(color.rgb, float3(1.0, 0.0, 0.0), p0.x);
color.rgb = lerp(color.rgb, float3(0.0, 1.0, 0.0), p0.y);
#line 524
float2 p1 = step(y, params.p1);
p1.x *= step(0.02, uv.x) * step(uv.x, 0.03);
p1.y *= step(0.03, uv.x) * step(uv.x, 0.04);
color.rgb = lerp(color.rgb, float3(1.0, 0.0, 0.5), p1.x);
color.rgb = lerp(color.rgb, float3(0.0, 1.0, 0.5), p1.y);
#line 530
float w = step(y, params.w);
w *= step(0.04, uv.x) * step(uv.x, 0.05);
color.rgb = lerp(color.rgb, 1.0, w);
#line 534
float2 overshoot = step(y, params.overshoot);
overshoot.x *= step(0.05, uv.x) * step(uv.x, 0.06);
overshoot.y *= step(0.06, uv.x) * step(uv.x, 0.07);
color.rgb = lerp(color.rgb, float3(1.0, 0.0, 1.0), overshoot.x);
color.rgb = lerp(color.rgb, float3(0.0, 1.0, 1.0), overshoot.y);
#line 540
float gamma = step(y, (params.gamma - 1.0) / 4.0);
gamma *= step(0.07, uv.x) * step(uv.x, 0.08);
color.rgb  = lerp(color.rgb, float3(1.0, 1.0, 0.0), gamma);
#line 544
float ruler = y % 0.025;
ruler = step(0.024, ruler);
ruler *= step(uv.x, 0.1);
color.rgb = lerp(color.rgb, 1.0 - color.rgb, ruler);
#line 549
float x = FullCurve_eval(curve, uv.x);
#line 563
y *= 0.5;
#line 565
float2 ps = ReShade::PixelSize * 4.0;
float line_ = step(x, y + ps.y) * step(y - ps.y, x);
#line 568
color.rgb = lerp(color.rgb, 1.0 - color.rgb, line_);
#line 570
return color;
}
#line 577
technique PiecewiseFilmicTonemap
{
pass Main
{
VertexShader = PostProcessVS;
PixelShader = MainPS;
#line 584
SRGBWriteEnable = true;
}
#line 591
}
#line 593
technique PiecewiseFilmicTonemap_Debug
{
pass
{
VertexShader = PostProcessVS;
PixelShader = DebugPS;
}
}

