#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Sketch.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 14 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Sketch.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 15 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Sketch.fx"
#line 45
static const int SmoothingSamples =  5;
static const float SmoothingSamplesInv = 1.0 / SmoothingSamples;
static const float SmoothingSamplesHalf = SmoothingSamples / 2;
#line 49
static const float2 ZeroOne = float2(0.0, 1.0);
#line 70
sampler SRGBBackBuffer
{
Texture = ReShade::BackBufferTex;
SRGBTexture = true;
};
#line 97
uniform float4 PatternColor
<
     ui_type = "color"; 
#line 101
ui_label = "Pattern Color";
ui_tooltip = "Default: 255 255 255 16";
> = float4(255, 255, 255, 16) / 255;
#line 105
uniform float2 PatternRange
<
     ui_type = "drag"; 
#line 109
ui_label = "Pattern Range";
ui_tooltip = "Default: 0.0 0.5";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.01;
> = float2(0.0, 0.5);
#line 116
uniform float OutlineThreshold
<
     ui_type = "drag"; 
#line 120
ui_label = "Outline Threshold";
ui_tooltip = "Default: 0.01";
ui_min = 0.001;
ui_max = 0.1;
ui_step = 0.001;
> = 0.01;
#line 127
uniform float Posterization
<
     ui_type = "drag"; 
#line 131
ui_tooltip = "Default: 5";
ui_min = 1;
ui_max = 255;
ui_step = 1;
> = 5;
#line 139
uniform float SmoothingScale
<
     ui_type = "slider"; 
#line 143
ui_label = "Smoothing Scale";
ui_tooltip = "Default: 1.0";
ui_min = 1.0;
ui_max = 10.0;
ui_step = 0.01;
> = 1.0;
#line 169
float get_depth(float2 uv)
{
return ReShade::GetLinearizedDepth(uv);
}
#line 174
float3 get_normals(float2 uv)
{
float3 ps = float3(ReShade::PixelSize, 0.0);
#line 178
float3 normals;
normals.x = get_depth(uv - ps.xz) - get_depth(uv + ps.xz);
normals.y = get_depth(uv + ps.zy) - get_depth(uv - ps.zy);
normals.z = get_depth(uv);
#line 183
normals.xy = abs(normals.xy) * 0.5 * ReShade::ScreenSize;
normals = normalize(normals);
#line 186
return normals;
}
#line 189
float get_outline(float2 uv)
{
float3 normals = get_normals(uv);
#line 193
float outline = dot(normals, float3(0.0, 0.0, 1.0));
outline = step(OutlineThreshold, outline);
#line 196
return outline;
}
#line 199
float get_pattern(float2 uv)
{
#line 209
float x = uv.x + uv.y;
x = abs(x);
x %= 0.0125;
x /= 0.0125;
x = abs((x - 0.5) * 2.0);
x = step(0.5, x);
#line 216
return x;
#line 218
}
#line 220
float3 test_palette(float3 color, float2 uv)
{
float2 bw = float2(1.0, 0.0);
uv.y = 1.0 - uv.y;
uv.y *= 20.0;
#line 226
return (uv.y < 0.333)
? uv.x * bw.xyy
: (uv.y < 0.666)
? uv.x * bw.yxy
: (uv.y < 1.0)
? uv.x * bw.yyx
: color;
}
#line 235
float3 cel_shade(float3 color, out float gray)
{
gray = dot(color, 0.333);
color -= gray;
#line 240
gray *= Posterization;
gray = round(gray);
gray /= Posterization;
#line 244
color += gray;
return color;
}
#line 250
float3 blur_old(sampler s, float2 uv, float2 dir)
{
dir *= SmoothingScale;
#line 254
uv -= SmoothingSamplesHalf * dir;
float3 color = tex2D(s, uv).rgb;
#line 257
[unroll]
for (int i = 1; i < SmoothingSamples; ++i)
{
uv += dir;
color += tex2D(s, uv).rgb;
}
#line 264
color *= SmoothingSamplesInv;
return color;
}
#line 268
float3 blur_depth_threshold(sampler s, float2 uv, float2 dir)
{
dir *= SmoothingScale;
#line 272
float depth = get_depth(uv);
#line 274
uv -= SmoothingSamplesHalf * dir;
float4 color = 0.0;
#line 277
[unroll]
for (int i = 0; i < SmoothingSamples; ++i)
{
float z = get_depth(uv);
if (abs(z - depth) < 0.001)
color += float4(tex2D(s, uv).rgb, 1.0);
#line 284
uv += dir;
}
#line 287
color.rgb /= color.a;
return color.rgb;
}
#line 291
float3 blur(sampler s, float2 uv, float2 dir)
{
dir *= SmoothingScale;
#line 295
float3 center = tex2D(s, uv).rgb;
#line 297
uv -= SmoothingSamplesHalf * dir;
float4 color = 0.0;
#line 300
[unroll]
for (int i = 0; i < SmoothingSamples; ++i)
{
float3 pixel = tex2D(s, uv).rgb;
float delta = dot(1.0 - abs(pixel - center), 0.333);
#line 306
if (delta > 0.9		)
color += float4(pixel, 1.0);
}
#line 310
color.rgb /= color.a;
return color.rgb;
}
#line 322
float4 BlurXPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float2 dir = float2((1.0 / 1920), 0.0);
float3 color = blur(SRGBBackBuffer, uv, dir);
return float4(color, 1.0);
}
#line 329
float4 BlurYPS(float4 p : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float2 dir = float2(0.0, (1.0 / 1080));
float3 color = blur(ReShade::BackBuffer, uv, dir);
return float4(color, 1.0);
}
#line 338
void MainVS(
uint id : SV_VERTEXID,
out float4 p : SV_POSITION,
out float2 uv : TEXCOORD0,
out float2 pattern_uv : TEXCOORD1)
{
PostProcessVS(id, p, uv);
#line 346
pattern_uv = uv;
pattern_uv.x *= ReShade::AspectRatio;
}
#line 350
float4 MainPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD0,
float2 pattern_uv : TEXCOORD1) : SV_TARGET
{
float4 color = tex2D(ReShade::BackBuffer, uv);
#line 368
float gray;
color.rgb = cel_shade(color.rgb, gray);
#line 371
float pattern = get_pattern(pattern_uv);
pattern *= 1.0 - smoothstep(PatternRange.x, PatternRange.y, gray);
pattern *= (1.0 - gray) * PatternColor.a;
color.rgb = lerp(color.rgb, PatternColor.rgb, pattern);
#line 376
float outline = get_outline(uv);
color.rgb *= outline;
#line 379
return color;
}
#line 386
technique Sketch
{
#line 389
pass BlurX
{
VertexShader = PostProcessVS;
PixelShader = BlurXPS;
}
pass BlurY
{
VertexShader = PostProcessVS;
PixelShader = BlurYPS;
SRGBWriteEnable = true;
}
#line 401
pass Main
{
VertexShader = MainVS;
PixelShader = MainPS;
}
}

